(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.dlx = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
/* eslint-disable new-cap */

const Emitter = require('./Emitter');

const BaseCollection = Emitter.extend(Array);

/**
 * A class for collections of models
 * @alias Collection
 * @memberof dlx.module:base
 * @extends Array
 * @extends dlx.module:base.Emitter
 * @type {Function}
 */
class Collection extends BaseCollection {
  /**
   * Create a new Collection
   * @type {Array}
   * @param {Array}  [data = []]    An array of models to create the Collection from.
   * @param {Object} [options = {}] An options object
   * @param {Object} [options.model] The constructor for the model to use in this collection. If provided, each item in the collection will become an instance of this model.
   */
  constructor(data = [], options = {}) {

    // VALIDATION
    if (data instanceof Collection) return data;

    if (!(Array.isArray(data) || data instanceof Set)) {
      throw new Error(`The data passed to the Collection constructor must be an Array.`);
    }

    // INSTANTIATION
    const Model = options.model || Object;
    const items = Array.from(data).map(item => new Model(item));

    super(...items);

    this.model = Model;

    // VALIDATION FOR PROPERTIES AND METHODS
    const handler = {
      // NB: don't use shorthand property syntax here, in order to keep 'this' value the same
      set: (target, prop, val, proxy) => {

        if (Number.isInteger(Number(prop))) {
          return Reflect.set(target, prop, new this.model(val), proxy);
        }

        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  fill(val, start, end) {
    super.fill(new this.model(val), start, end);
  }

  push(...args) {
    super.push(...args.map(item => new this.model(item)));
  }

  splice(start, deleteCount, ...args) {
    super.splice(start, deleteCount, ...args.map(item => new this.model(item)));
  }

  unshift(...args) {
    super.unshift(...args.map(item => new this.model(item)));
  }

}

module.exports = Collection;

},{"./Emitter":3}],2:[function(require,module,exports){
/**
 * An Event Emitter for DOM Nodes. Accepts a single DOM Node as input, and allows events to be registered on the Node with the usual emitter methods (`.on()`, `.off()`, etc.), except for `.emit()` (since the DOM emits the event automatically). This allows for easy registering and deregistering of events. The event map is stored directly on the DOM node, so that it isn't necessary to retain a reference to the element.
 * @alias DOMListener
 * @memberof dlx.module:base
 * @type {Function}
 */
class DOMListener {
  /**
   * Create a new DOMListener
   * @param {Object|String} el The DOM Node or DOM selector string to use for this element
   */
  constructor(el) {

    if (!(el instanceof Node || typeof el === 'string')) {
      throw new Error(`The "el" attribute must be a DOM Node or a DOM selector string.`);
    }

    Object.defineProperty(this, 'el', {
      configurable: false,
      enumerable: true,
      value: el instanceof Node ? el : document.querySelector(el),
      writable: false
    });

    const events = new Map();

    if (!this.el.events) {
      Object.defineProperty(this.el, 'events', {
        configurable: false,
        enumerable: true,
        value: events,
        writable: false
      });
    }

    this.events = this.el.events;

    this.el.off = this.off.bind(this);
    this.el.on = this.on.bind(this);
    this.el.once = this.once.bind(this);
  }

  /**
   * Unsubscribe one or more listeners from the element.
   * @param  {String}   [event]    The event to remove. If none is specified, all events will be removed.
   * @param  {Function} [callback] The callback to remove. If none is specified, all callbacks for the specified event will be removed.
   * @param  {Object}   [options]  The options for the event listener. See the [options object of the DOM's addEventListener method]{@link https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/addEventListener}.
   * @return {Object}              Returns the DOM Listener object.
   */
  off(event, callback, options) {

    if (callback) {

      const listeners = this.events.get(event);

      if (listeners) {
        this.el.removeEventListener(event, callback, options);
        listeners.delete(callback);
        if (listeners.size === 0) this.events.delete(event);
      }
    } else if (event) {

      const listeners = this.events.get(event);

      if (listeners) {
        listeners.forEach(listener => this.el.removeEventListener(event, listener, options));
      }

      this.events.delete(event);
    } else {

      this.events.forEach((listeners, ev) => {

        listeners.forEach(cb => {
          this.el.removeEventListener(ev, cb, options);
        });
      });

      this.events.clear();
    }

    return this;
  }

  /**
   * Subscribe a callback to an event
   * @param  {String}   event     The name of the event to subscribe to. Must be a valid [event type]{@link https://developer.mozilla.org/en-US/docs/Web/Events}.
   * @param  {Function} callback  The function to invoke when the event is fired
   * @param  {Object}   [options] The options for the event listener. See the [options object of the DOM's addEventListener method]{@link https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/addEventListener}.
   * @return {Object}             Returns the DOM Listener object
   */
  on(event, callback, options) {
    if (!this.events.has(event)) this.events.set(event, new Set());
    this.el.addEventListener(event, callback, options);
    this.events.get(event).add(callback);
    return this;
  }

  /**
   * Subscribe a callback to an event to fire exactly once. After the callback is invoked, it will be removed from the listeners.
   * @param  {String}   event    The name of the event to subscribe to. Must be a valid [event type]{@link https://developer.mozilla.org/en-US/docs/Web/Events}.
   * @param  {Function} callback The function to invoke when the event is fired.
   * @return {Object}            Returns the DOM Listener object
   */
  once(event, callback) {

    const triggerAndRemove = () => {
      callback();
      this.off(event, callback);
    };

    this.on(event, triggerAndRemove, { once: true });

    return this;
  }

}

module.exports = DOMListener;

},{}],3:[function(require,module,exports){
class Super {}

/**
 * A class representing an Event Emitter
 * @alias Emitter
 * @memberof dlx.module:base
 * @type {Function}
 *
 * @example
 * // The Model class will inherit from Emitter
 * class Model extends Emitter {
 *   ...
 * }
 *
 * @example
 * // The Collection class will have both Array and Emitter methods, and can be subclassed further
 * class Collection = Emitter.extend(Array) {
 *   ...
 * }
 */
class Emitter {
  /**
   * Create a new Event Emitter
   * @type {Object}
   */
  constructor() {

    Object.defineProperty(this, 'events', {
      configurable: false,
      enumerable: false,
      value: new Map(),
      writable: false
    });
  }

  /**
   * Triggers the callbacks for a given event. Subsequent arguments will be passed to the event callbacks.
   * @param  {String} event  The event name to trigger
   * @param  {Any}    [args] Additional arguments to pass to the event callback
   * @return {Object}        Returns a Promise that resolves when all callbacks are complete
   */
  emit(event, ...args) {
    if (typeof event !== 'string') throw new TypeError('The event name must be a string.');
    const listeners = this.events.get(event);
    if (listeners) return Promise.all(Array.from(listeners).map(cb => cb(...args)));
    return Promise.resolve();
  }

  /**
   * Unsubscribe from one or more events on this object
   * @param {String}   [event]    The event to remove. If none is specified, all events will be removed.
   * @param {Function} [callback] The callback to remove. If none is specified, all callbacks for the specified event will be removed.
   * @return {Object}             Returns the Emitter object
   */
  off(event, callback) {

    if (callback) {

      const listeners = this.events.get(event);

      if (listeners) {
        listeners.delete(callback);
        if (listeners.size === 0) this.events.delete(event);
      }
    } else if (event) {

      this.events.delete(event);
    } else {

      this.events.clear();
    }

    return this;
  }

  /**
   * Subscribe to an event on this object, by binding a callback function to the name of the event. Callbacks may be Promises or regular functions.
   * @param  {String|Object} event    The name of the event to subscribe to. May also be an object mapping event names to callback functions
   * @param  {Function}      callback The callback function to invoke whenever the specified event is fired
   * @return {Object}                 Returns the emitter object
   */
  on(event, callback) {

    const addEvent = (ev, cb) => {

      if (typeof cb !== 'function') {
        throw new TypeError('Callback must be a function.');
      }

      if (!this.events.has(ev)) this.events.set(ev, new Set());
      this.events.get(ev).add(cb);
    };

    if (typeof event === 'object') {

      for (const ev in event) {
        if (event.hasOwnProperty(ev)) {
          addEvent(ev, event[ev]);
        }
      }
    } else {

      addEvent(event, callback);
    }

    return this;
  }

  /**
   * Subscribe to an event on this object for one time only. After the event is triggered, the callback will be removed. Callbacks may be Promises or regular functions.
   * @param  {String}   event    The name of the event to subscribe to
   * @param  {Function} callback The callback function to invoke when the event is fired
   * @return {Object}            Returns the emitter object
   */
  once(event, callback) {

    if (typeof event !== 'string') {
      throw new TypeError('The event argument must be a string.');
    }

    if (typeof callback !== 'function') {
      throw new TypeError('The callback must be a function.');
    }

    const triggerAndRemove = () => {
      callback();
      const listeners = this.events.get(event);
      listeners.delete(triggerAndRemove);
      if (listeners.size === 0) this.events.delete(event);
    };

    this.on(event, triggerAndRemove);

    return this;
  }

  /**
   * Mixin the Event Emitter into another class. This method takes the provided class, adds the Emitter methods to it, and returns a new class that you can then subclass further.
   * @param {Function} [Superclass] A class constructor to mixin the Emitter with
   * @return {Function}             Returns the new class with the Emitter methods mixed in
   * @example
   * const Collection = Emitter.extend(Array);
   */
  static extend(Superclass = Super) {

    return class extends Superclass {
      constructor(...args) {
        super(...args);
        const props = Object.getOwnPropertyDescriptors(Emitter.prototype);
        Object.defineProperties(this, props);
      }
    };
  }

}

module.exports = Emitter;

},{}],4:[function(require,module,exports){
/* eslint-disable new-cap */

const Collection = require('./Collection');
const createElement = require('../utilities').createElement;
const View = require('./View');

/**
 * A base view for lists / collections. This view is not a subclass of the View constructor.
 * @alias ListView
 * @memberof dlx.module:base
 * @extends dlx.module:base.View
 * @type {Function}
 */
class ListView extends View {
    /**
     * Create a new List View
     * @type {Object}
     * @param {Array}    [collection = []]     The Collection of models to create the List View from
     * @param {Object}   [options = {}]        An options object
     * @param {Function} [options.view = View] A View constructor to use for each item in the list
     */
    constructor(collection = [], options = {}) {

        const view = options.view || View;
        const opts = Object.assign({ view }, options);

        super(collection, opts);

        this.collection = new Collection(collection);
        this.view = view;
    }

    /**
     * Compiles the List View template using the Collection data
     * @return {Object} Returns a UL element containing the collection of views
     */
    template() {

        const list = createElement('ul', { classList: 'list' });

        this.model.forEach(model => {

            const container = createElement('li');
            const view = new this.view(model, this.options);

            view.render({ container });
            list.appendChild(container);
        });

        return list;
    }

}

module.exports = ListView;

},{"../utilities":32,"./Collection":1,"./View":6}],5:[function(require,module,exports){
const Emitter = require('./Emitter');

/**
 * A base Model that other models inherit from. It also has a few static methods that are useful in creating subclasses.
 * @alias Model
 * @memberof dlx.module:base
 * @type {Object}
 * @extends dlx.module:base.Emitter
 */
class Model extends Emitter {

  /**
   * A no-op destroy function. This method should be overwritten on the subclass with logic to delete the model from the database.
   */
  destroy() {}

  /**
   * A no-op save function. This method should be overwritten on the subclass with logic to save the model data to a database.
   */
  save() {}

  /**
   * Returns a JSON representation of this model, as a string
   * @return {String} The JSON string
   */
  get json() {
    return JSON.stringify(this.toJSON(), null, 2);
  }

  /**
   * Adds an array property to the provided object with the given property name. The array property will be enumerable but non-configurable and non-writable. Each item added to the array will be made an instance of the provided model.
   * @param {Object}   object              The object to add the array property to
   * @param {String}   propName            The name of the array property to add
   * @param {Function} model               A constructor function to apply to each item before being added to the array.
   * @param {Array}    [initialValue = []] The intial set of items to add to the array property.
   */
  static defineArray(object, propName, model, initialValue = []) {

    if (!Array.isArray(initialValue)) {
      throw new TypeError(`The "${propName}" property must be an array.`);
    }

    const ItemModel = model;
    const isString = ItemModel === String;

    const handler = {
      set(target, prop, val, proxy) {

        let newVal = val;

        if (Number.isInteger(Number(prop))) {
          if (isString && typeof val !== 'string') {
            throw new TypeError(`Each of the items in "${propName}" must be a String.`);
          } else if (!isString) {
            newVal = new ItemModel(val);
          }
        }

        return Reflect.set(target, prop, newVal, proxy);
      }
    };

    const p = new Proxy([], handler);

    p.push(...initialValue);

    Object.defineProperty(object, propName, {
      configurable: true,
      enumerable: true,
      value: p,
      writable: false
    });
  }

  /**
   * Adds a property to the provided object which may only have the specified values
   * @param  {Object} object       The object to add the property to
   * @param  {String} propName     The name of the property to add
   * @param  {Array}  values       An array of acceptable values for the new property
   * @param  {Any}    initialValue The initial value to give to the new property. Will be `undefined` if none is provided.
   * @return {Object}              Returns the original object with the new property added
   */
  static defineEnumProp(object, propName, values, initialValue) {

    if (!(object instanceof Object)) {
      throw new TypeError(`The "object" argument must be an Object.`);
    }

    if (!Array.isArray(values)) {
      throw new TypeError(`The "values" argument must be an array of allowed values.`);
    }

    const o = object;

    let value;

    Object.defineProperty(o, propName, {
      configurable: true,
      enumerable: true,
      get() {
        return value;
      },
      set(val) {

        if (!values.includes(val)) {
          throw new Error(`The value provided is not a valid value for the "${propName}" property.`);
        }

        value = val;
      }
    });

    if (typeof initialValue !== 'undefined') o[propName] = initialValue;

    return o;
  }

  /**
   * Adds a property with the given name to the provided object, and ensures that the value of the property is always an instance of the provided model. The property will be enumerable and writable but non-configurable.
   * @param {Object}   object         The object to add the property to
   * @param {String}   propName       The name of the property to add
   * @param {Function} model          A constructor function. The value of this property will always be an instance of the provided function.
   * @param {Any}      [initialValue] The initial value to use for the value of this property. If none is provided, the value will be undefined until the property is set.
   * @return {Object}                 Returns the original object with the new property added
   */
  static defineProp(object, propName, model, initialValue) {

    if (!(object instanceof Object)) throw new TypeError(`The "object" argument must be an Object.`);

    const o = object;
    const PropModel = model;
    const isDate = PropModel === Date;
    const isString = PropModel === String;

    let value;

    Object.defineProperty(o, propName, {
      configurable: true,
      enumerable: true,
      get() {
        return value;
      },
      set(val) {

        if (isString) {

          if (typeof val !== 'string') {
            throw new TypeError(`The "${propName}" property must be a String.`);
          }

          value = val;
        } else if (isDate) {

          if (isNaN(Date.parse(val))) {
            throw new TypeError(`The "${propName}" property must be a valid Date string or object.`);
          }

          value = new Date(val);
        } else if (typeof val !== 'undefined') {

          value = new PropModel(val);
        }
      }
    });

    if (typeof initialValue !== 'undefined') o[propName] = initialValue;

    return o;
  }

  /**
   * Takes an Object and an Array of required properties, and returns a simplified version of the object with all empty Arrays, Strings, Sets, Maps, and basic Objects removed. This is useful when trying to reduce the footprint of the object when stringifying it.
   * @param  {Object} model           The Object to simplify
   * @param  {Array}  [required = []] A Array of required property names. These properties will not be removed from the object, even if they are empty
   * @return {Object}                 Returns a *new* object with the properties removed
   */
  static simplify(model, required = []) {

    if (!(model instanceof Object)) {
      throw new TypeError(`The "model" argument must be an Object.`);
    }

    if (!Array.isArray(required) || required.some(val => typeof val !== 'string')) {
      throw new TypeError(`The "required" argument must be an Array of Strings.`);
    }

    const o = Object.assign({}, model);

    for (const prop in model) {

      if (!required.includes(prop)) {

        if (Array.isArray(o[prop]) && !o[prop].length || (o[prop] instanceof Set || o[prop] instanceof Map) && !o[prop].size || o[prop] && o[prop].constructor === Object && !Object.keys(o[prop]).length || typeof o[prop] !== 'number' && !o[prop]) {
          delete o[prop];
        }
      }
    }

    return o;
  }

}

module.exports = Model;

},{"./Emitter":3}],6:[function(require,module,exports){
const { toDOM } = require('../utilities');
const Emitter = require('./Emitter');
const DOMListener = require('./DOMListener');

/**
 * A base View class that other views inherit from
 * @alias View
 * @memberof dlx.module:base
 * @extends  dlx.module:base.Emitter
 * @type {Object}
 * @prop {Object}   el        The DOM element attached to this view (this Node exists whether or not it has been inserted into the DOM). This may be either the container element where you'll insert HTML, or the actual element to insert into the DOM. Will be an empty div if no element was provided during intialization.
 * @prop {Object}   model     The data for this view
 * @prop {String}   position  The position within the container element to insert this view
 * @prop {Function} template  The templating function for this view. May return either an HTML string or a single DOM Node.
 */
class View extends Emitter {
  /**
   * Create a new View
   * @type  {Function}
   * @param {Object}        [data = {}]                The model or raw data to create the view from
   * @param {Object}        [options = {}]             An options object.
   * @param {Object|String} [options.container]        The container to insert the view into. May be either a DOM Node or a DOM selector string. If provided, the `.render()` method may be called without the `container` option.
   * @param {Object|String} [options.el]               If provided, this option sets the value of the `el` property of the View. May be either a DOM Node or a DOM selector string. This is typically either the container element that the render method will insert HTML in, or the actual element to be inserted. If this option is provided, the `template` method will not be invoked.
   * @param {String}        [options.position = 'end'] The position to render this view at within its container. Possible value are `start` (inserts the view as the first element in the container), `end` (inserts the view as the last element in the container), and `replace` (clears all child nodes from the container before inserting this view). If provided, the `.render()` method may be called without the `position` option provided.
   * @param {Boolean}       [options.template]         A templating function that accepts the view's model as an input, and returns either an HTML string or DOM Node. This method may also simply be provided as a method on the view subclass.
   */
  constructor(data = {}, options = {}) {

    super();

    this.model = data;
    this.options = options;
    this.position = options.position || 'end';
    this.template = options.template || this.template;

    if (options.container) {
      this.container = options.container instanceof Node ? options.container : document.querySelector(options.container);
    }

    let el;

    Object.defineProperty(this, 'el', {
      configurable: false,
      enumerable: true,
      get() {
        return el;
      },
      set(val) {
        el = new DOMListener(val).el;
        return el;
      }
    });

    if (options.el) {
      this.el = options.el instanceof Node ? options.el : document.querySelector(options.el);
    }

    this.el = this.el || toDOM(this.template(data))[0] || document.createElement('div');
  }

  /**
   * Clears the container element of any HTML and removes all listeners from this View, without removing the container element from the DOM
   * @return {Object} Returns the view object
   */
  clear() {
    this.container.innerHTML = '';
    this.off();
    return this;
  }

  /**
   * Removes all listeners from this View, and removes its container element from the DOM
   * @return {Object} Returns the view object
   */
  remove() {
    this.el.remove();
    this.off();
    return this;
  }

  /**
   * Inserts this view into the DOM, within the specified container. You will often want to overwrite this function on the subclass.
   * @param {Object}        [options = {}]             An options object
   * @param {Object|String} [options.container]        A container element to render the view in. May be either a DOM selector string or a DOM Node. If this option was already provided in the view's `container` option, this argument may be omitted.
   * @param {String}        [options.position = 'end'] The position to render this view at within its container. Possible value are `start` (inserts the view as the first element in the container), `end` (inserts the view as the last element in the container), and `replace` (clears all child nodes from the container before inserting this view). If this option was already provided in the view's `position` option, this argument may be omitted.
   * @return {Object}                          Returns this view object
   */
  render(options = {}) {

    if (typeof options !== 'object') throw new Error(`Render options must be an object.`);

    const container = options.container || this.container;
    const position = options.position || this.position;

    if (!(options.container instanceof Node || typeof options.container === 'string')) {
      throw new TypeError(`The "container" option must be a DOM Node or a DOM selector string.`);
    }

    const wrapper = container instanceof Node ? container : document.querySelector(container);

    switch (position) {

      case 'start':
        {
          const { firstChild } = wrapper;
          wrapper.insertBefore(this.el, firstChild);
          break;
        }

      case 'replace':
        {
          wrapper.innerHTML = '';
          wrapper.appendChild(this.el);
          break;
        }

      default:
        wrapper.appendChild(this.el);

    }

    return this;
  }

  /**
   * A no-op template function, to be replaced by a template function on the view subclass. The template function should accept the model data as the first argument, and return either an HTML string or a DOM Node. This may also be provided in the `template` option.
   */
  template() {}

}

module.exports = View;

},{"../utilities":32,"./DOMListener":2,"./Emitter":3}],7:[function(require,module,exports){
/**
 * Base models for other types of classes
 * @memberof dlx
 * @module base
 * @type {Object}
 * @prop {Function} Collection  A base class for Collections
 * @prop {Function} DOMListener A DOM Listener object
 * @prop {Function} Emitter     A base class for Event Emitters
 * @prop {Function} ListView    A base class for List Views
 * @prop {Function} Model       A base class for Models
 * @prop {Function} View        A base class for Views
 */

module.exports = {
  Collection: require('./Collection'),
  DOMListener: require('./DOMListener'),
  Emitter: require('./Emitter'),
  ListView: require('./ListView'),
  Model: require('./Model'),
  View: require('./View')
};

},{"./Collection":1,"./DOMListener":2,"./Emitter":3,"./ListView":4,"./Model":5,"./View":6}],8:[function(require,module,exports){
/**
 * An object containing linguistic data, e.g. data about the IPA
 * @module data
 * @memberof dlx
 * @type {Object}
 * @prop {Array}  punctuation                     An array of common punctuation characters used in the world's writing systems
 * @prop {Object} phonologicalFeatures            An object containing lists of distinctive features in phonology
 * @prop {Array}  phonologicalFeatures.airstream  A list of airstream mechanisms
 * @prop {Array}  phonologicalFeatures.backness   A list of horizontal positions in the mouth (front-back)
 * @prop {Array}  phonologicalFeatures.diacritics A list of diacritical features
 * @prop {Array}  phonologicalFeatures.height     A list of vertical positions in the mouth
 * @prop {Array}  phonologicalFeatures.length     A list of lengths for vowels and consonants
 * @prop {Array}  phonologicalFeatures.manner     A list of manners of articulation
 * @prop {Array}  phonologicalFeatures.place      A list of places of articulation
 * @prop {Array}  phonologicalFeatures.rounding   A list of rounding types
 * @prop {Array}  phonologicalFeatures.voicing    A list of voicing types
 */

const punctuation = [`.`, // \u002e
`,`, // \u002c
`;`, // \u003b
`:`, // \u003a
`!`, // \u0021
`?`, // \u003f
`'`, // \u0027
`"`, // \u0022
`‘`, // \u2018
`’`, // \u2019
`“`, // \u201c
`”`, // \u201d
`[`, // \u005b
`]`, // \u005d
`(`, // \u0028
`)`, // \u0029
`{`, // \u007b
`}`, // \u007d
`⟨`, // \u27e8
`⟩`, // \u27e9
`–`, // \u2013
`—`, // \u2014
`―`, // \u2015
`…`, // \u2026
`«`, // \u00ab
`»`, // \u00bb
`/`, // \u002f
`\\`, // \u005c
`<`, // \u003c
`>`, // \u003e
`¡`, // \u00a1
`¿`, // \u00bf
`‚`, // \u201a
`‛`, // \u201b
`„`, // \u201E
`‟`, // \u201f
`‹`, // \u2039
`›`, // \u203A
`「`, // \u300c
`」`, // \u300d
`『`, // \u300e
`』`, // \u300F
`〝`, // \u301d
`〞`, // \u301e
`〟`, // \u301f
`﹁`, // \ufe41
`﹂`, // \ufe42
`﹃`, // \ufe43
`﹄`, // \ufe44
`＂`, // \uff02
`＇`, // \uff07
`｢`, // \uff62
`｣`, // \uFF63
`、`, // \u3001
`،`, // \u060c
`&`, // \u0026
`*`, // \u002a
`•`, // \u2022
`^`, // \u005e
`†`, // \u2020
`‡`, // \u2021
`°`, // \u00b0
`″`, // \u2033
`#`, // \u0023
`$`, // \u0024
`%`, // \u0025
`‰`, // \u2030
`+`, // \u002b
`−`, // \u2212
`=`, // \u003d
`′`, // \u2032
`″`, // \u2033
`‴`, // \u2034
`§`, // \u00a7
`~`, // \u007e
`|`, // \u007c
`‖`, // \u2016
`¦`, // \u00a6
`©`, // \u00a9
`®`];

/**
 * Airstream mechanisms
 * @enum {String}
 * @instance
 * @prop {String} airstream click
 * @prop {String} airstream ejective
 * @prop {String} airstream implosive
 * @prop {String} airstream pulmonic
 */
const airstream = ['click', 'ejective', 'implosive', 'ingressive', 'pulmonic'];

/**
 * Backness of a vowel
 * @enum {String}
 * @instance
 * @prop {String} backness front
 * @prop {String} backness near-front
 * @prop {String} backness central
 * @prop {String} backness near-back
 * @prop {String} backness back
 */
const backness = ['front', 'near-front', 'central', 'near-back', 'back'];

/**
 * A list of diacritical features
 * @enum {String}
 * @instance
 * @prop {String} diacritics advanced
 * @prop {String} diacritics advanced tongue root
 * @prop {String} diacritics affricativized
 * @prop {String} diacritics alveolar
 * @prop {String} diacritics apical
 * @prop {String} diacritics aspirated
 * @prop {String} diacritics breathy
 * @prop {String} diacritics centralized
 * @prop {String} diacritics close
 * @prop {String} diacritics creaky
 * @prop {String} diacritics dental
 * @prop {String} diacritics fortis
 * @prop {String} diacritics fricativized
 * @prop {String} diacritics labialized
 * @prop {String} diacritics laminal
 * @prop {String} diacritics lateral release
 * @prop {String} diacritics lax
 * @prop {String} diacritics lenis
 * @prop {String} diacritics lightly aspirated
 * @prop {String} diacritics linguolabial
 * @prop {String} diacritics lowered
 * @prop {String} diacritics mid-centralized
 * @prop {String} diacritics nasal release
 * @prop {String} diacritics nasalized
 * @prop {String} diacritics no release
 * @prop {String} diacritics non-syllabic
 * @prop {String} diacritics open
 * @prop {String} diacritics palatalized
 * @prop {String} diacritics pharyngealized
 * @prop {String} diacritics plain
 * @prop {String} diacritics raised
 * @prop {String} diacritics retracted
 * @prop {String} diacritics retracted tongue root
 * @prop {String} diacritics retroflexed
 * @prop {String} diacritics rhotic
 * @prop {String} diacritics rounded
 * @prop {String} diacritics sibilant
 * @prop {String} diacritics syllabic
 * @prop {String} diacritics tense
 * @prop {String} diacritics unrounded
 * @prop {String} diacritics velarized
 * @prop {String} diacritics voiced
 * @prop {String} diacritics voiceless
 * @prop {String} diacritics weakly aspirated
 */
const diacritics = ['advanced', 'advanced tongue root', 'affricativized', 'alveolar', 'apical', 'aspirated', 'breathy', 'centralized', 'close', 'creaky', 'dental', 'fortis', 'fricativized', 'labialized', 'laminal', 'lateral release', 'lax', 'lenis', 'lightly aspirated', 'linguolabial', 'lowered', 'mid-centralized', 'nasal release', 'nasalized', 'no release', 'non-syllabic', 'open', 'palatalized', 'pharyngealized', 'plain', 'raised', 'retracted', 'retracted tongue root', 'retroflexed', 'rhotic', 'rounded', 'sibilant', 'syllabic', 'tense', 'unrounded', 'velarized', 'voiced', 'voiceless', 'weakly aspirated'];

/**
 * A list of vowel heights
 * @enum {String}
 * @instance
 * @prop {String} height close
 * @prop {String} height near-close
 * @prop {String} height close-mid
 * @prop {String} height mid
 * @prop {String} height open-mid
 * @prop {String} height near-open
 * @prop {String} height open
 */
const height = ['close', 'near-close', 'close-mid', 'mid', 'open-mid', 'near-open', 'open'];

/**
 * A list of types of lengths of segments
 * @enum {String}
 * @instance
 * @prop {String} length extra long
 * @prop {String} length extra short
 * @prop {String} length geminate
 * @prop {String} length half long
 * @prop {String} length long
 * @prop {String} length short
 */
const length = ['extra long', 'extra short', 'geminate', 'half long', 'long', 'short'];

/**
 * A list of manners of articulation
 * @enum {String}
 * @instance
 * @prop {String} manner approximate
 * @prop {String} manner flap
 * @prop {String} manner fricative
 * @prop {String} manner lateral
 * @prop {String} manner nasal
 * @prop {String} manner plosive
 * @prop {String} manner tap
 * @prop {String} manner trill
 */
const manner = ['approximate', 'flap', 'fricative', 'lateral', 'nasal', 'plosive', 'tap', 'trill'];

/**
 * A list of places of articulation
 * @enum {String}
 * @instance
 * @prop {String} place bilabial
 * @prop {String} place labiodental
 * @prop {String} place labiovelar
 * @prop {String} place dental
 * @prop {String} place alveolar
 * @prop {String} place lateral
 * @prop {String} place post-alveolar
 * @prop {String} place alveo-palatal
 * @prop {String} place palato-alveolar
 * @prop {String} place retroflex
 * @prop {String} place palatal
 * @prop {String} place velar
 * @prop {String} place uvular
 * @prop {String} place pharyngeal
 * @prop {String} place glottal
 * @prop {String} place epiglottal
 */
const place = ['bilabial', 'labiodental', 'labiovelar', 'dental', 'alveolar', 'lateral', 'post-alveolar', 'alveo-palatal', 'palato-alveolar', 'retroflex', 'palatal', 'velar', 'uvular', 'pharyngeal', 'glottal', 'epiglottal'];

/**
 * A list of types of rounding
 * @enum {String}
 * @instance
 * @prop {String} rounding compressed
 * @prop {String} rounding protruded
 * @prop {String} rounding rounded
 * @prop {String} rounding unrounded
 */
const rounding = ['compressed', 'protruded', 'rounded', 'unrounded'];

/**
 * A list of voicing values
 * @enum {String}
 * @instance
 * @prop {String} voicing semivoiced
 * @prop {String} voicing voiced
 * @prop {String} voicing voiceless
 */
const voicing = ['semivoiced', 'voiced', 'voiceless'];

const phonologicalFeatures = {
  airstream,
  backness,
  diacritics,
  height,
  length,
  manner,
  place,
  rounding,
  voicing
};

module.exports = {
  phonologicalFeatures,
  punctuation
};

},{}],9:[function(require,module,exports){
/**
 * The DLx object
 * @module dlx
 * @type {Object}
 * @prop {Object} base      Base models for other classes
 * @prop {Object} data      An object containing linguistic data, e.g. data about the IPA. See [dlx.data]{@link dlx.module:data}.
 * @prop {Object} models    Data models for linguistic objects, such as Text, Phrase, Word, etc. See [dlx.models]{@link dlx.module:models}.
 * @prop {Object} utilities A collection of utility functions. See [dlx.utils]{@link dlx.module:utils}.
 * @prop {Object} utils     Alias for dlx.utilities
 * @prop {Object} views     A collection of Views for various linguistic objects. See [dlx.views]{@link dlx.module:views}.
 */
const dlx = {
  base: require('./base'),
  data: require('./data'),
  models: require('./models'),
  utilities: require('./utilities'),
  utils: require('./utilities'),
  views: require('./views')
};

module.exports = dlx;

},{"./base":7,"./data":8,"./models":31,"./utilities":32,"./views":33}],10:[function(require,module,exports){
const { Model } = require('../base');
const MultiLangString = require('./MultiLangString');

const AILLAValues = ['depositor control', 'password', 'public access', 'time limit'];

const ELARValues = ['Community Member', 'Researcher', 'Subscriber', 'User'];

const checkVal = val => {
  if (!(typeof val === 'string' || typeof val === 'boolean')) {
    throw new TypeError(`Properties on the Access object must be either a Boolean or String.`);
  }
};

/**
 * A class representing a set of access protocols.
 * @alias Access
 * @memberof dlx.module:models
 * @prop {String}          AILLA A string describing the access rights for this resource in terms of AILLA's access level schema.
 * @prop {String}          ELAR A string describing the access rights for this resource in terms of ELAR's access level schema.
 * @prop {MultiLangString} notes Notes about access rights for this resource, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 */
class Access {
  /**
   * Create a new Access Rights object
   * @param {Object} [data]       The data to use for this Access object
   * @param {String} [data.AILLA] A string describing the access rights for this resource in terms of AILLA's access level schema. Acceptable values are "depositor control", "password", "public access", or "time limit".
   * @param {String} [data.ELAR]  A string describing the access rights for this resource in terms of ELAR's access level schema. Acceptable values are "Community Member", "Researcher", "Subscriber", or "User".
   * @param {Object} [data.notes] Notes about access rights for this resource, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   */
  constructor(data = {}) {

    if (!(data instanceof Object)) {
      throw new TypeError(`The data passed to the Access constructor must be an Object.`);
    }

    Object.entries(data).forEach(([key, val]) => {
      if (key !== 'notes') checkVal(val);
    });

    Object.assign(this, data);

    Model.defineProp(this, 'notes', MultiLangString, data.notes || {});

    let AILLA;
    let ELAR;

    Object.defineProperties(this, {

      AILLA: {
        configurable: false,
        enumerable: true,
        get() {
          return AILLA;
        },
        set(val) {

          if (!AILLAValues.includes(val)) {
            throw new Error(`The AILLA access level must be one of "depositor control", "password", "public access", or "time limit".`);
          }

          AILLA = val;
        }
      },

      ELAR: {
        configurable: false,
        enumerable: true,
        get() {
          return ELAR;
        },
        set(val) {

          if (!ELARValues.includes(val)) {
            throw new Error(`The ELAR access level must be one of "Community Member", "Researcher", "Subscriber", or "User".`);
          }

          ELAR = val;
        }
      }

    });

    const handler = {
      set(target, prop, val, proxy) {
        if (prop !== 'notes') checkVal(val);
        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this);
  }

}

module.exports = Access;

},{"../base":7,"./MultiLangString":20}],11:[function(require,module,exports){
const { Model } = require('../base');

/**
 * A class representing a postal address
 * @alias Address
 * @memberof dlx.module:models
 * @prop {String} apartmentNumber The apartment or unit number, along with any abbreviations, e.g. Apt 20
 * @prop {String} country         The country this address is located in
 * @prop {String} locality        The locality or city for this Address
 * @prop {String} postalBoxNumber The postal box number
 * @prop {String} postalCode      The postal code for this address (as a string rather than a number)
 * @prop {String} region          The region or state for this Address
 * @prop {String} streetAddress   The street address, not including apartment or unit number
 */
class Address {
  /**
   * Create a new postal address
   * @param {Object} [data]                 The data to use for this address
   * @param {String} [data.apartmentNumber] The apartment or unit number, along with any abbreviations, e.g. Apt 20.
   * @param {String} [data.country]         The country this address is located in
   * @param {String} [data.locality]        The locality or city for this Address
   * @param {String} [data.postalBoxNumber] The postal box number
   * @param {String} [data.postalCode]      The postal code for this address (as a string rather than a number)
   * @param {String} [data.region]          The region or state for this Address
   * @param {String} [data.streetAddress]   The street address, not including apartment or unit number
   */
  constructor(data = {}) {

    if (!(data instanceof Object)) {
      throw new TypeError(`The data passed to the Address constructor must be an Object.`);
    }

    Object.entries(data).forEach(([key, val]) => {
      if (val && typeof val !== 'string') throw new TypeError(`The "${key}" property must be a String.`);
    });

    Object.assign(this, data);

    Model.defineProp(this, 'apartmentNumber', String, data.apartmentNumber);
    Model.defineProp(this, 'country', String, data.country);
    Model.defineProp(this, 'locality', String, data.locality);
    Model.defineProp(this, 'postalBoxNumber', String, data.postalBoxNumber);
    Model.defineProp(this, 'postalCode', String, data.postal);
    Model.defineProp(this, 'region', String, data.region);
    Model.defineProp(this, 'streetAddress', String, data.streetAddress);

    const handler = {
      set(target, prop, val, proxy) {
        if (typeof val !== 'string') {
          throw new TypeError(`The "${prop}" property must be a String.`);
        }
        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this);
  }

}

module.exports = Address;

},{"../base":7}],12:[function(require,module,exports){
const { Model } = require('../base');
const MultiLangString = require('./MultiLangString');

const defaults = {
  environments: [],
  transcription: {}
};

/**
 * A class representing an Allomorph of a Lexeme
 * @alias Allomorph
 * @memberof dlx.module:models
 * @prop {Set}             environments  A set of the (morpho)phonological environments for this allomorph
 * @prop {MultiLangString} transcription The transcription of this allomorph, as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}
 * @prop {String}          txn           A shorthand for accessing the default orthography of the `transcription` object, if one is set
 * @example
 * const allomorph = new Allomorph({
 *   environments:  ['_i', '_y'],
 *   transcription: { ipa: 't͡ʃ' }
 * });
 *
 * console.log(allomorph.transcription.ipa);      // t͡ʃ
 * console.log(allomorph.environments.has('_i')); // true
 */
class Allomorph {
  /**
   * Create a new Allomorph
   * @param {Object}          [data]             The data to use for the Allomorph
   * @param {Array|Set}       data.environments  An Array or Set of environments, as strings. May be empty.
   * @param {MultiLangString} data.transcription A transcription of this allomorph, optionally in multiple orthographies. Do not include any leading or trailing tokens (e.g. hyphens, equal signs). Should be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   */
  constructor(data = defaults) {

    // VALIDATION
    if (data instanceof Allomorph) return data;

    if (typeof data !== 'object') {
      throw new Error(`The data passed to the Allomorph constructor must be an object.`);
    }

    if (data.environments && !(Array.isArray(data.environments) || data.environments instanceof Set)) {
      throw new Error(`The "environements" property must be an Array or Set.`);
    }

    // INSTANTIATION
    Object.assign(this, data);

    Model.defineProp(this, 'transcription', MultiLangString, data.transcription || {});

    MultiLangString.alias(this, 'transcription', 'txn');

    const environments = new Set();

    // proxies environments.add for validation when new items are added
    Object.defineProperty(environments, 'add', {
      configurable: false,
      enumerable: false,
      value: new Proxy(environments.add, {
        apply(target, context, [val]) {
          if (typeof val !== 'string') {
            throw new TypeError(`The value to add to "environments" must be a String.`);
          }
          return Reflect.apply(target, context, [val]);
        }
      }),
      writable: false
    });

    // prevents 'environments' from being overwritten, which would lose its proxied `add` method
    Object.defineProperty(this, 'environments', {
      configurable: false,
      enumerable: true,
      value: environments,
      writable: false
    });

    Array.from(data.environments || []).forEach(env => this.environments.add(env));
  }

  toJSON() {
    const data = Model.simplify(this, ['environments', 'transcription']);
    data.environments = Array.from(this.environments);
    return data;
  }

}

module.exports = Allomorph;

},{"../base":7,"./MultiLangString":20}],13:[function(require,module,exports){
const { Model } = require('../base');
const MultiLangString = require('./MultiLangString');

const props = ['allographs', 'form', 'name', 'pronunciations'];

/**
 * A class representing a grapheme
 * @alias Grapheme
 * @memberof dlx.module:models
 * @prop {Array}           allographs     An Array of all the allographs (graphical / writing variants) of the current grapheme
 * @prop {String}          form           The written form of this grapheme
 * @prop {MultiLangString} name           The name of this grapheme (if any), as a [MultiLangString]{@link dlx.module:models.MultiLangString}
 * @prop {Array}           pronunciations An array of pronunciations of this grapheme, in IPA, as Strings
 */
class Grapheme {
  /**
   * Create a new Grapheme
   * @param {Object} [data]                The data to use for this Grapheme object
   * @param {Array}  [data.allographs]     An Array of all the allographs (graphical / writing variants) of the current grapheme, as Strings
   * @param {String} data.form             The written form of this grapheme, as a String
   * @param {Object} [data.name]           The name of this grapheme (if any), formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}
   * @param {Array}  [data.pronunciations] An array of pronunciations of this grpaheme, in IPA, as Strings
   */
  constructor(data = {}) {

    if (!(data instanceof Object)) {
      throw new TypeError('The data passed to the Grapheme constructor must be an Object.');
    }

    Model.defineProp(this, 'form', String, data.form || '');
    Model.defineProp(this, 'name', MultiLangString, data.name || {});

    Model.defineArray(this, 'allographs', String, data.allographs);
    Model.defineArray(this, 'pronunciations', String, data.pronunciations);

    const handler = {
      set(target, prop, val, proxy) {
        if (!props.includes(prop)) return false;
        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this, ['form']);
  }

}

module.exports = Grapheme;

},{"../base":7,"./MultiLangString":20}],14:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');
const Location = require('./Location');
const MultiLangString = require('./MultiLangString');
const Orthography = require('./Orthography');
const Phoneme = require('./Phoneme');

const checkGlottolog = val => {
  if (!/[a-z]{4}[0-9]{4}/.test(val)) {
    throw new Error(`The Glottolog code must be formatted as a String of 4 letters followed by 4 numbers.`);
  }
};

const checkISO = val => {
  if (!/^[a-z]{3}$/.test(val)) {
    throw new Error(`The ISO code must be formatted as a 3-letter String.`);
  }
};

const checkNames = names => {

  if (!(Array.isArray(names) || names instanceof Set)) {
    throw new TypeError(`The "additionalNames" property must be an Array or Set.`);
  }

  names.forEach(val => {
    if (typeof val !== 'string') {
      throw new TypeError(`Each item in the "additionalNames" property must be a String.`);
    }
  });
};

/**
 * A class representing a Language
 * @alias Language
 * @memberof dlx.module:models
 * @extends Model
 * @prop {String}          abbreviation    An abbreviation for this Language, as a String.
 * @prop {Set}             additionalNames A Set of additional names for this language, as Strings.
 * @prop {Date}            dateCreated     The date and time that this Language object was created
 * @prop {Date}            dateModified    The date and time that this Language object was last modified. Setting any property on this object will update this property automatically.
 * @prop {Array}           locations       An Array of locations where this language variety is spoken, as [Location objects]{@link dlx.module:models.Location}.
 * @prop {String}          glottolog       The Glottolog code for this language variety
 * @prop {String}          iso             The ISO 639-3 code for this language variety
 * @prop {MultiLangString} name            The name of this language, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {Array}           orthographies   An Array of orthographies used by this language, each as an [Orthography object]{@link dlx.module:models.Orthography}
 * @prop {Array}           phonemes        An Array of phonemes in this language, as [Phoneme objects]{@link dlx.module:models.Phoneme}.
 * @prop {URL}             url             The URL where the JSON data for this language may be retrieved, as a valid URI
 */
class Language extends Model {
  /**
   * Create a new Language
   * @param {Object}      [data]                 The data to use for this Language object
   * @param {String}      [data.abbreviation]    An abbreviation for this language, formatted as a valid [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/Abbreviation.html}.
   * @param {Array|Set}   [data.additionalNames] An Array or Set of additional names for this language, as Strings.
   * @param {Object}      [data.codes]           An Object containing two properties, `glottolog` and `iso`, each of which must be Arrays or Sets of Strings.
   * @param {Date|String} [data.dateCreated]     The date and optionally time that the data for this Language object was originally created, as either a Date object or a valid date string. If none is provided, this property will be set automatically upon instantiation.
   * @param {Date|String} [data.dateModified]    The date and optionally time that the data for this Language object was last modified, as either a Date object or a valid date string. If none is provided, this property will be set automatically upon instantiation.
   * @param {String}      [data.glottolog]       The Glottolog code for this language variety
   * @param {String}      [data.iso]             The ISO 639-3 code for this language variety
   * @param {Array}       [data.locations]       An Array of locations where this language variety is spoken, each formatted as a [Location object]{@link http://developer.digitallinguistics.io/spec/schemas/Location.html}.
   * @param {Object}      data.name              The name of this language, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   * @param {Array}       [data.orthographies]   An Array of orthographies used by this language, each formatted as an [Orthography object]{@link http://developer.digitallinguistics.io/spec/schemas/Orthography.html}
   * @param {Array}       [data.phonemes]        An Array of phonemes in this language, formatted as [Phoneme objects]{@link http://developer.digitallinguistics.io/spec/schemas/Phoneme.html}.
   * @param {URL}         [data.url]             The URL where the JSON data for this language may be retrieved, as a valid URI
   */
  constructor(data = {}) {

    // VALIDATION
    if (!(data instanceof Object)) {
      throw new TypeError(`The data passed to the Language constructor must be an Object.`);
    }

    if ('abbreviation' in data) checkProp(data.abbreviation, 'abbr', 'abbreviation');

    if ('additionalNames' in data) checkNames(data.additionalNames);

    if ('glottolog' in data) checkGlottolog(data.glottolog);

    if ('iso' in data) checkISO(data.iso);

    if ('url' in data) checkProp(data.url, 'url', 'url');

    // INITIALIZATION
    super();

    Object.assign(this, data);

    this.additionalNames = new Set(data.additionalNames);

    Model.defineProp(this, 'dateCreated', Date, data.dateCreated || new Date());
    Model.defineProp(this, 'dateModified', Date, data.dateModified || new Date());
    Model.defineProp(this, 'name', MultiLangString, data.name || {});

    Model.defineArray(this, 'locations', Location, data.locations);
    Model.defineArray(this, 'orthographies', Orthography, data.orthographies);
    Model.defineArray(this, 'phonemes', Phoneme, data.phonemes);

    // PROXY VALIDATION FOR SETTERS
    const handler = {
      set(target, prop, val, proxy) {

        switch (prop) {
          case 'abbreviation':
            checkProp(val, 'abbr', 'abbreviation');break;
          case 'additionalNames':
            checkNames(val);break;
          case 'glottolog':
            checkGlottolog(val);break;
          case 'iso':
            checkISO(val);break;
          case 'url':
            checkProp(val, 'url', 'url');break;
          default:
            break;
        }

        target.dateModified = new Date();

        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    const data = Model.simplify(this, ['name']);
    if (data.additionalNames) data.additionalNames = Array.from(data.additionalNames);
    return data;
  }

}

module.exports = Language;

},{"../base":7,"../utilities":32,"./Location":18,"./MultiLangString":20,"./Orthography":22,"./Phoneme":24}],15:[function(require,module,exports){
const { checkProp, getUniqueReferences } = require('../utilities');
const { Model } = require('../base');

// don't use destructuring with index.js here - causes problematic circular references
const Allomorph = require('./Allomorph');
const LexemeReference = require('./LexemeReference');
const LexicalRelation = require('./LexicalRelation');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Phrase = require('./Phrase');
const Reference = require('./Reference');
const Sense = require('./Sense');
const Tags = require('./Tags');
const Variant = require('./Variant');

class Features extends Tags {
  constructor(data) {

    super(data);

    if (Array.from(this.values()).some(val => typeof val !== 'string')) {
      throw new TypeError(`Feature values must be Strings`);
    }

    Object.defineProperty(this, 'set', {
      configurable: false,
      enumerable: false,
      value: new Proxy(this.set, {
        apply(target, context, args) {
          if (!args.every(arg => typeof arg === 'string')) {
            throw new Error(`Features and their values must be strings.`);
          }
          return Reflect.apply(target, context, args);
        }
      }),
      writable: false
    });
  }
}

const defaults = {
  lemma: {},
  senses: []
};

/**
 * A class representing a Lexeme
 * @alias Lexeme
 * @memberof dlx.module:models
 * @extends Model
 * @prop {Array}           allomorphs        An array of allomorphs of this lexeme. See the [Allomorph]{@link dlx.module:models.Allomorph} class for more details.
 * @prop {MultiLangString} citationForm      An object containing transcriptions of the citation form of this lexeme, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String}          citation          A shorthand for accessing the default orthography of the `transcription` object, if one is set
 * @prop {Array}           components        An array of Lexeme References to other lexemes that are components of the current lexeme. Each item is an instance of [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Date}            dateCreated       A Date object representing the time this lexeme was originally created
 * @prop {Date}            dateModified      A Date object representing the time this lexeme was last updated. This property is updated automatically when certain simple properties of the lexeme are changed.
 * @prop {Array}           examples          An array of example phrases illustrating this lexeme's uses
 * @prop {Map}             features          A Map object containing grammatical features and values for this lexeme. See the [MDN documentation on the Map object]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details about its properties and methods.
 * @prop {String}          headword          A shorthand for accessing the default orthography of the `lemma` object, if one is set
 * @prop {Array}           includedIn        An array containing references to each lexeme that the current lexeme is a component of. Each item is a [LexemeReference object]{@link dlx.module:models.LexemeReference}.
 * @prop {String}          key               A human-readable key that uniquely identifies this lexeme or variant within its lexicon.
 * @prop {MultiLangString} lemma             The lemma form of this lexeme, as a [MultiLangString]{@link dlx.module:models:MultiLangString}.
 * @prop {Array}           lexicalRelations  An array of the lexical relations that this lexeme has to other lexemes or variants.
 * @prop {MultiLangString} literalMeaning    A [MultiLangString]{@link dlx.module:models.MultiLangString} containing the literal meaning of this lexeme.
 * @prop {String}          literal           A shorthand for accessing the default orthography of the `literalMeaning` object, if one is set
 * @prop {MultiLangString} morphemeType      A [MultiLangString]{@link dlx.module:models.MultiLangString} containing the morpheme type for this lexeme.
 * @prop {String}          morphType         A shorthand for accessing the default orthography of the `morphemeType` object, if one is set
 * @prop {Array}           notes             An array of notes about this lexeme. Each note is an instance of the [Note class]{@link dlx.module:models.Note}.
 * @prop {Array}           references        An array of bibliographic references about this lexeme. Each item is an instance of the [Reference class]{@link dlx.module:models.Reference}.
 * @prop {Array}           senses            An array of senses for this lexeme. Each item is a [Sense object]{@link dlx.module.models.Sense}.
 * @prop {Array}           sources           An array of attested sources for this lexeme, as strings.
 * @prop {String}          syllableStructure An abstract representation of the syllable structure of this form, e.g. `CVC`.
 * @prop {Tags}            tags              A Map object containing tags and values for this lexeme. See the [MDN documentation on the Map object]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details about its properties and methods.
 * @prop {String}          tone              A string representing the tonal pattern of this lexeme or variant. Examples: `HLH`, `323`, etc.
 * @prop {String}          url               A URI where this lexeme can be accessed, as a string.
 * @prop {LexemeReference} variantOf         A [LexemeReference object]{@link dlx.module:models.LexemeReference} containing a reference to another lexeme or sense, which the current lexeme is a variant of.
 * @prop {Array}           variants          An array of variants of this lexeme. Each item is a [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {MultiLangString} variantType       If this lexeme is a variant of another lexeme or sense, this field can be used to specify the type of variant. Possible values might be a person's name (representing an idiolectal variant), or simply `idiolectal`, or `dialectal`, or the name of the dialect, or `rapid speech`, etc. This field is a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String}          varType           A shorthand for accessing the default orthography of the `variantType` object, if one is set
 */
class Lexeme extends Model {
  /**
   * Create a new Lexeme
   * @param {Object}       [data]                   The raw data for the lexeme. See the [DLx specification for a Lexeme]{@link http://developer.digitallinguistics.io/spec/schemas/Lexeme.html} for more information on formatting Lexeme data.
   * @param {Array}        [data.allomorphs]        An array of allomorphs. You can use the [Allomorph class]{@link dlx.module:models.Allomorph} to ensure the data is formatted correctly.
   * @param {Object}       [data.citationForm]      The citation form for this lexeme, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   * @param {Array}        [data.components]        An array of Lexeme References to other lexemes that are components of the current lexeme. Each item must be formatted as a [LexemeReference object]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}.
   * @param {String|Date}  [data.dateCreated]       A date string or date object representing the time this lexeme was originally created. If none is supplied, dateCreated will be set to the current date-time.
   * @param {String|Date}  [data.dateModified]      A date string or date object representing the time this lexeme was last modified. If none is supplied, dateModified will be set to the current date-time.
   * @param {Array}        [data.examples]          An array of example phrases illustrating this lexeme's uses. Each item must be formatted as a [Phrase]{@link http://developer.digitallinguistics.io/spec/schemas/Phrase.html}.
   * @param {Object|Array} [data.features]          An object containing grammatical features and their values. May also be a Map object.
   * @param {Array}        [data.includedIn]        An Array of references to lexemes that have the current lexeme as a component. Each item should be formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}.
   * @param {String}       [data.key]               A human-readable key that uniquely identifies this lexeme or variant within its lexicon. Best practice is for the key to consist of the lemma form of the word in the default orthography, and if the word is a homonym, the homonym number. However, any value is acceptable as long as it is unique within the lexicon. (Keys do not need to be unique across lexicons.) Must be formatted as an [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
   * @param {Object}       data.lemma               The lemma form of this lexeme. A lemma is the particular form conventionally used to represent a particular lexeme. It may differ drastically from the citation form or headword form. For example, the form be is typically used as the lemma form of the English verb to be, with its variants am, are, is, etc. Lemmas may be represented in multiple orthographies. Do not include any leading or trailing tokens (e.g. hyphens, equal signs). Must be in the format of a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}
   * @param {Array}        [data.lexicalRelations]  An array of objects formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}, with an additional required "relation" property. See the [Lexeme format]{@link http://developer.digitallinguistics.io/spec/schemas/Lexeme.html} for more details.
   * @param {Object}       [data.literalMeaning]    The literal meaning of the lexeme, optionally in multiple orthographies. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   * @param {Object}       [data.morphemeType]      The type of morpheme or complex construction that this lexeme is, optionally in multiple languages. Examples: root, stem, bipartite stem, enclitic, prefix, inflected word, phrase, circumfix. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   * @param {Array}        [data.notes]             An array of notes about this lexeme. Each note should adhere to the [Note format]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
   * @param {Array}        [data.references]        An array of bibliographic references about this lexeme. Each item should adhere to the [Reference format]{@link http://developer.digitallinguistics.io/spec/schemas/Reference.html}.
   * @param {Array}        data.senses              An array of senses for this lexeme. Each item should be formatted as a Sense object. See the [Lexeme schema]{@link http://developer.digitallinguistics.io/spec/schemas/Lexeme.html} for more details.
   * @param {Array}        [data.sources]           An array of attested sources for this lexeme, as strings. This will often be the initials of a speaker, but could also be the abbreviation of the story the lexeme was found it, or other types of sources.
   * @param {String}       [data.syllableStructure] An abstract representation of the syllable structure of this form, as a string, e.g. `CVC`.
   * @param {Object|Array} [data.tags]              An object containing tags and their values. May also be an iterable object, whose items are arrays of tags and their values (in other words, the standard method for instantiating a new Map object; see [MDN's Map documentation]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details).
   * @param {String}       [data.tone]              A string representing the tonal pattern of this lexeme or variant. Examples: `HLH`, `323`, etc.
   * @param {String}       [data.url]               A URI where this lexeme can be accessed, as a string.
   * @param {Object}       [data.variantOf]         When this lexeme is a variant of another lexeme, this field should contain a reference (formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}) to the other Lexeme. Lexemes may only be variants of one other Lexeme.
   * @param {Array}        [data.variants]          An array of variants of this lexeme. Each item should be formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}, and must also have the "variantType" property specified.
   * @param {Object}       [data.variantType]       If this lexeme is a variant of another lexeme or sense, this field can be used to specify the type of variant. Possible values might be a person's name (representing an idiolectal variant), or simply `idiolectal`, or `dialectal`, or the name of the dialect, or `rapid speech`, etc. Must be in the format of a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   */
  constructor(data = defaults) {

    // VALIDATION
    if (data instanceof Lexeme) return data;

    if (typeof data !== 'object') {
      throw new TypeError(`The data passed to the Lexeme constructor must be an object.`);
    }

    if ('key' in data) checkProp(data.key, 'abbr', 'key');

    if ('url' in data) checkProp(data.url, 'url', 'url');

    // INSTANTIATION
    super();

    Object.assign(this, data);

    Model.defineProp(this, 'citationForm', MultiLangString, data.citationForm);
    Model.defineProp(this, 'dateCreated', Date, data.dateCreated || new Date());
    Model.defineProp(this, 'dateModified', Date, data.dateModified || new Date());
    Model.defineProp(this, 'lemma', MultiLangString, data.lemma || {});
    Model.defineProp(this, 'literalMeaning', MultiLangString, data.literalMeaning);
    Model.defineProp(this, 'features', Features, data.features || {});
    Model.defineProp(this, 'morphemeType', MultiLangString, data.morphemeType || {});
    Model.defineProp(this, 'syllableStructure', String, data.syllableStructure);
    Model.defineProp(this, 'tags', Tags, data.tags || {});
    Model.defineProp(this, 'tone', String, data.tone);
    Model.defineProp(this, 'variantOf', LexemeReference, data.variantOf);
    Model.defineProp(this, 'variantType', MultiLangString, data.variantType);

    Model.defineArray(this, 'allomorphs', Allomorph, data.allomorphs);
    Model.defineArray(this, 'components', LexemeReference, data.components);
    Model.defineArray(this, 'examples', Phrase, data.examples);
    Model.defineArray(this, 'includedIn', LexemeReference, getUniqueReferences(data.includedIn || []));
    Model.defineArray(this, 'lexicalRelations', LexicalRelation, getUniqueReferences(data.lexicalRelations || []));
    Model.defineArray(this, 'notes', Note, data.notes);
    Model.defineArray(this, 'references', Reference, data.references);
    Model.defineArray(this, 'senses', Sense, data.senses);
    Model.defineArray(this, 'sources', String, data.sources);
    Model.defineArray(this, 'variants', Variant, getUniqueReferences(data.variants || []));

    MultiLangString.alias(this, 'citationForm', 'citation');
    MultiLangString.alias(this, 'lemma', 'headword');
    MultiLangString.alias(this, 'literalMeaning', 'literal');
    MultiLangString.alias(this, 'morphemeType', 'morphType');
    MultiLangString.alias(this, 'variantType', 'varType');

    // VALIDATION FOR SETTERS
    const handler = {
      set(target, prop, val, proxy) {

        switch (prop) {
          case 'key':
            checkProp(val, 'abbr', 'key');break;
          case 'url':
            checkProp(val, 'url', 'url');break;
          default:
            break;
        }

        // update "dateModified" whenever a property is set
        target.dateModified = new Date();

        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this, ['lemma', 'senses']);
  }

}

module.exports = Lexeme;

},{"../base":7,"../utilities":32,"./Allomorph":12,"./LexemeReference":16,"./LexicalRelation":17,"./MultiLangString":20,"./Note":21,"./Phrase":25,"./Reference":26,"./Sense":27,"./Tags":28,"./Variant":29}],16:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');
const MultiLangString = require('./MultiLangString');

/**
 * A class representing a Lexeme Reference
 * @alias LexemeReference
 * @memberof dlx.module:models
 * @prop {String}          lexeme      The key (abbreviation) of the lexeme being referenced
 * @prop {String}          lexemeUrl   The URL of the referenced lexeme. Must be a valid URI.
 * @prop {String}          lexicon     The key (abbreviation) of the lexicon being referenced
 * @prop {String}          lexiconUrl  The URL of the referenced lexicon. Must be a valid URI.
 * @prop {String}          relation    The type of relation that holds between this item and the referenced lexeme
 * @prop {Integer}         sense       The index of the sense being referenced
 * @prop {MultiLangString} variantType The type of variant that the referenced lexeme is. A [MultiLangString]{@link dlx.module:models.MultiLangString}.
 *
 * @example
 * const ref = new LexemeReference('calle1');
 *
 * console.log(ref.lexeme); // calle1
 *
 * @example
 * const ref = new LexemeReference({
 *   lexeme:  'calle1',
 *   lexicon: 'spanish',
 * });
 *
 * console.log(ref.lexeme); // calle1
 */
class LexemeReference {
  /**
   * Create a new Lexeme Reference.
   * @param {Object|String} [data]             The data to use for the Lexeme Reference. If the data is a string, that string will become the "lexeme" property, indicating the key of the referenced lexeme. Otherwise an object must be passed containing a "lexeme" property.
   * @param {String}        data.lexeme        The key (abbreviation) of the lexeme being referenced
   * @param {String}        [data.lexemeUrl]   The URL of the referenced lexeme. Must be a valid URI.
   * @param {String}        [data.lexicon]     The key (abbreviation) of the lexicon being referenced
   * @param {String}        [data.relation]    A string indicating the type of relationship between the current item and the referenced lexeme. This property is required when the reference is being used in the "lexicalRelations" property of the Lexeme.
   * @param {Integer}       [data.sense]       The number of the sense being reference (i.e. its index in the senses array). Note that the senses array is zero-indexed.
   * @param {Object}        [data.variantType] The type of variant that the referenced lexeme is. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   */
  constructor(data = '') {

    // VALIDATION
    if (data && typeof data !== 'object' && typeof data !== 'string') {

      throw new Error(`The data passed to the LexemeReference constructor must be an object or string.`);
    } else if (typeof data === 'object') {

      if ('lexemeUrl' in data) checkProp(data.lexemeUrl, 'url', 'lexemeUrl');
      if ('lexiconUrl' in data) checkProp(data.lexiconUrl, 'url', 'lexiconUrl');
      if ('relation' in data) checkProp(data.relation, 'abbr', 'relation');
      if ('sense' in data) checkProp(data.sense, 'integer', 'sense');
    }

    // INSTANTIATION
    if (typeof data === 'string') {
      this.lexeme = data;
    } else if (typeof data === 'object') {
      this.lexeme = data.lexeme || '';
      if ('lexemeUrl' in data) this.lexemeUrl = data.lexemeUrl;
      if ('lexicon' in data) this.lexicon = data.lexicon;
      if ('lexiconUrl' in data) this.lexiconUrl = data.lexiconUrl;
      if ('sense' in data) this.sense = data.sense;
      if ('relation' in data) this.relation = data.relation;
      Model.defineProp(this, 'variantType', MultiLangString, data.variantType);
    }

    MultiLangString.alias(this, 'variantType', 'varType');

    // VALIDATION FOR SETTERS
    const handler = {
      set(target, prop, val, proxy) {

        switch (prop) {
          case 'lexeme':
          case 'lexicon':
          case 'relation':
            checkProp(val, 'abbr', prop);
            break;
          case 'lexemeUrl':
          case 'lexiconUrl':
            checkProp(val, 'url', prop);
            break;
          case 'sense':
            checkProp(val, 'integer', 'sense');break;
          default:
            return false;
        }

        return Reflect.set(target, prop, val, proxy);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this, ['lexeme']);
  }

}

module.exports = LexemeReference;

},{"../base":7,"../utilities":32,"./MultiLangString":20}],17:[function(require,module,exports){
const LexemeReference = require('./LexemeReference');

class LexicalRelation extends LexemeReference {
  constructor(data) {
    super(data);
    if (typeof this.relation !== 'string') {
      throw new Error(`The lexical relation must have a "relation" property.`);
    }
  }
}

module.exports = LexicalRelation;

},{"./LexemeReference":16}],18:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');
const Access = require('./Access');
const Address = require('./Address');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Reference = require('./Reference');
const Tags = require('./Tags');

/**
 * A class representing a Location
 * @alias Location
 * @memberof dlx.module:models
 * @prop {String}          abbreviation An abbreviation for this location, as a String.
 * @prop {Access}          access       An Object describing the access protocols for this location, as an [Access object]{@link dlx.module:models.Access}.
 * @prop {Address}         address      An Object describing a postal address for this location, as an [Address object]{@link dlx.module:models.Address}.
 * @prop {Date}            dateCreated  The date and optionally that this Location data was originally created, as a Date object.
 * @prop {Date}            dateModified The date and optionally that this Location data was last modified, as a Date object.
 * @prop {Object}          geoJSON      A GeoJSON Object containing geospatial data about this location
 * @prop {MultiLangString} name         The name of this location, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {Array}           notes        An array of notes about this location. Each item is a [Note object]{@link dlx.module:models.Note}.
 * @prop {Array}           references   An array of bibliographic freferences about this location. Each item is a [Reference object]{@link dlx.module:models.Reference}.
 * @prop {Tags}            tags         A Map object containing tags for this location, as a [Tags object]{@link dlx.module:models.Tags}.
 * @prop {String}          url          The URL where this location data can be downloaded in JSON format.
 */
class Location {
    /**
     * Create a new Location
     * @param {Object}        [data]              The data to use for this Location object
     * @param {String}        [data.abbreviation] An abbreviation for this location, formatted as an [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/Abbreviation.html}.
     * @param {Object}        [data.access]       An Object describing the access protocols for this location, formatted as an [Access object]{@link http://developer.digitallinguistics.io/spec/schemas/Access.html}.
     * @param {Object}        [data.address]      An Object describing a postal address for this location, formatted as an [Address]{@link http://developer.digitallinguistics.io/spec/schemas/Address.html}.
     * @param {Object|String} [data.dateCreated]  The date and optionally time that this Location data was originally created, as a Date object or date string.
     * @param {Object|String} [data.dateModified] The date and optionally time that this Location data was last modified, as a Date object or date string.
     * @param {Object}        [data.geoJSON]      A GeoJSON Object containing geospatial data about this location. Must be formatted as valid [GeoJSON]{@link http://geojson.org/}.
     * @param {Object}        data.name           The name of this Location, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Array}         [data.notes]        An array of notes about this location. Each item should be formatted as a [Note object]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
     * @param {Array}         [data.references]   An array of bibliographic references about this location. Each item should be formatted as a [Reference object]{@link http://developer.digitallinguistics.io/spec/schemas/Reference.html}.
     * @param {Object}        [data.tags]         An Object or Map containing tags for this location, formatted as a [Tags object]{@link http://developer.digitallinguistics.io/spec/schemas/Tags.html}.
     * @param {String}        [data.url]          A URL where the JSON data for this location can be downloaded, as a URI.
     */
    constructor(data = {}) {

        // VALIDATION
        if (!(data instanceof Object)) {
            throw new TypeError(`The data passed to the Location constructor must be an Object.`);
        }

        if ('abbreviation' in data) checkProp(data.abbreviation, 'abbr', 'abbreviation');

        if ('url' in data) checkProp(data.url, 'url', 'url');

        // INSTANTIATION
        Object.assign(this, data);

        Model.defineProp(this, 'access', Access, data.access || {});
        Model.defineProp(this, 'address', Address, data.address);
        Model.defineProp(this, 'dateCreated', Date, data.dateCreated || new Date());
        Model.defineProp(this, 'dateModified', Date, data.dateModified || new Date());
        Model.defineProp(this, 'geoJSON', Object, data.geoJSON);
        Model.defineProp(this, 'name', MultiLangString, data.name || {});
        Model.defineProp(this, 'tags', Tags, data.tags || {});

        Model.defineArray(this, 'notes', Note, data.notes);
        Model.defineArray(this, 'references', Reference, data.references);

        // PROXY VALIDATION FOR SETTERS
        const handler = {
            set(target, prop, val, proxy) {

                switch (prop) {
                    case 'abbreviation':
                        checkProp(val, 'abbr', 'abbreviation');break;
                    case 'url':
                        checkProp(val, 'url', 'url');break;
                    default:
                        break;
                }

                target.dateModified = new Date();

                return Reflect.set(target, prop, val, proxy);
            }
        };

        return new Proxy(this, handler);
    }

    toJSON() {
        return Model.simplify(this, ['name']);
    }

}

module.exports = Location;

},{"../base":7,"../utilities":32,"./Access":10,"./Address":11,"./MultiLangString":20,"./Note":21,"./Reference":26,"./Tags":28}],19:[function(require,module,exports){
const { Model } = require('../base');
const LexemeReference = require('./LexemeReference');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Tags = require('./Tags');

const defaults = {
  gloss: {},
  transcription: {}
};

/**
 * A class representing a Morpheme Token
 * @alias Morpheme
 * @memberof dlx.module:models
 * @prop {MultiLangString} gloss         The gloss for this morpheme, as a [MultiLangString]{@link dlx.module:models:MultiLangString}.
 * @prop {String}          gl            A shorthand for accessing the default orthography of the `gloss` property.
 * @prop {Object}          lexeme        A reference to an item in a lexicon where more information about this morpheme can be found, as a [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Array}           notes         An array of notes about this morpheme. Each item should be a [Note object]{@link dlx.module:models.Note}.
 * @prop {Tags}            tags          A set of tags for this morpheme, as a [Tags object]{@link dlx.module:models.Tags}.
 * @prop {MultiLangString} transcription A transcription of this morpheme, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String}          txn           A shorthand for accessing the default orthography of the `transcription` property.
 */
class Morpheme extends Model {
  /**
   * Create a new Morpheme
   * @param {Object} [data = {}]          The data to use for this Morpheme Token
   * @param {Object} data.gloss           The gloss for this morpheme, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   * @param {Object} [data.lexeme]        A Lexeme Reference that points to an item in a lexicon where more information about this morpheme can be found.
   * @param {Array}  [data.notes]         An array of notes about this Morpheme. Each note should be formatted as a [Note object]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
   * @param {Object} [data.tags]          A set of tags for this morpheme, formatted as a [Tags object]{@link http://developer.digitallinguistics.io/spec/schemas/Tags.html}.
   * @param {Object} data.transcription   The transcription of this morpheme, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
   */
  constructor(data = defaults) {

    // VALIDATION
    if (!(data instanceof Object)) {
      throw new TypeError(`The "data" argument must be an Object.`);
    }

    // INSTANTIATION
    super();

    Object.assign(this, data);

    Model.defineProp(this, 'gloss', MultiLangString, data.gloss || {});
    Model.defineProp(this, 'lexeme', LexemeReference, data.lexeme || {});
    Model.defineProp(this, 'tags', Tags, data.tags || {});
    Model.defineProp(this, 'transcription', MultiLangString, data.transcription || {});

    Model.defineArray(this, 'notes', Note, data.notes);

    MultiLangString.alias(this, 'gloss', 'gl');
    MultiLangString.alias(this, 'transcription', 'txn');
  }

  toJSON() {
    return Model.simplify(this, ['gloss', 'transcription']);
  }

}

module.exports = Morpheme;

},{"../base":7,"./LexemeReference":16,"./MultiLangString":20,"./Note":21,"./Tags":28}],20:[function(require,module,exports){
const { isAbbr } = require('../utilities');
const { Model } = require('../base');

// validates a writing system key
const validateKey = key => {
  if (!isAbbr(key)) {
    throw new Error(`Each writing system key must be a valid Abbreviation.`);
  }
};

// validates a transcription string
const validateString = string => {
  if (typeof string !== 'string') {
    throw new Error(`Each transcription must be a string.`);
  }
};

/**
 * A class representing a transcription in one or more languages or writing systems.
 * @alias MultiLangString
 * @memberof dlx.module:models
 * @extends Map
 * @prop {String} default The default orthography to get and set. This property is not enumerable.
 * @example
 * const str = new MultiLangString({
 *   spa: 'Hola, me llamo Daniel.',
 *   ipa: 'ola me jamo danjɛl',
 * }, {
 *   default: 'spa',
 * });
 *
 * str.eng = 'Hello, my name is Daniel.';
 *
 * console.log(str.spa);     // Hola, me llamo Daniel.
 * console.log(str.ipa);     // ola me jamo danjɛl
 * console.log(str.default); // 'spa'
 */
class MultiLangString extends Map {
  /**
   * Create a new Multi-Language String
   * @param {Object}  [data]            The data for this transcription, as a plan Object or Map. See the [MultiLangString specification]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html} for more information on formatting transcription data.
   * @param {Object}  [options]         An options object
   * @param {String}  [options.default] The default orthography to get and set
   */
  constructor(data = {}, options = {}) {

    // VALIDATION
    if (data instanceof Map) return data;

    if (typeof data !== 'object') {
      throw new TypeError(`The data passed to the MultiLangString constructor must be an object.`);
    }

    if (typeof options !== 'object') {
      throw new TypeError(`The options argument must be an object.`);
    }

    Object.keys(data).forEach(validateKey);
    Object.values(data).forEach(validateString);

    // INSTANTIATION
    super(Object.entries(data));

    Model.defineProp(this, 'default', String, options.default);

    // VALIDATION FOR SETTERS
    const handler = {
      get(target, prop) {
        if (target[prop] instanceof Function) return target[prop].bind(target);
        return target.get(prop) || target[prop];
      },
      set(target, prop, val) {
        validateKey(prop);
        validateString(val);
        return target.set(prop, val);
      }
    };

    return new Proxy(this, handler);
  }

  toJSON() {
    const data = {};
    Array.from(this.entries()).forEach(([key, val]) => {
      data[key] = val;
    });
    return data;
  }

  /**
   * Adds a new property to the provided object. The new property is an alias for the default orthography of the given MultiLangString property (i.e., a shorthand for `object[mlsProp][object[mlsProp].default]`). The new property will not be configurable or enumerable, only writable.
   * @param  {Object} object      The object to add the alias property to
   * @param  {String} mlsProp     The name of the MultiLangString property whose default orthography you want to alias
   * @param  {String} defaultProp The name of the new alias property.
   * @return {Object}             Returns the object with the new property added
   *
   * @example
   * const phrase = {
   *   translation: new MultiLangString({
   *     default: 'eng',
   *     eng:     'Hello world!',
   *     spa:     'Hola mundo!',
   *   }),
   * };
   *
   * MultiLangString.alias(phrase, 'translation', 'tln');
   *
   * console.log(phrase.tln); // 'Hello world!'
   */
  static alias(object, mlsProp, defaultProp) {

    const o = object;

    Object.defineProperty(o, defaultProp, {
      configurable: false,
      enumerable: false,
      get() {
        return o[mlsProp][o[mlsProp].default];
      },
      set(val) {
        o[mlsProp][o[mlsProp].default] = val;
      }
    });

    return o;
  }

}

module.exports = MultiLangString;

},{"../base":7,"../utilities":32}],21:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');

const actions = ['defineProperty', 'deleteProperty', 'set'];

const props = ['dateCreated', 'dateModified', 'language', 'person', 'text', 'type'];

const types = [`note-to-self`, `general`, `anthropology`, `discourse`, `encyclopedic`, `grammar`, `phonology`, `semantics`, `sociocultural`];

/**
 * A class representing a Note
 * @alias Note
 * @memberof dlx.module:models
 * @prop {Date}   dateCreated  The date this note was originally created, as a Date object
 * @prop {Date}   dateModified The date this note was last modified, as a Date object. This property is automatically updated whenever a property of the note is altered.
 * @prop {String} language     The abbreviation for the language this note is written in, as a string.
 * @prop {String} person       The abbreviation of the person who is the source of the information in this note (not necessarily the person who wrote it).
 * @prop {String} text         The text of this note
 * @prop {String} type         The type of note
 *
 * @example
 * const note = new Note({
 *   text:     'This is a note.',
 *   language: 'eng',
 * });
 *
 * console.log(note.text); // This is a note.
 *
 * @example
 * const note = new Note('This is a note.');
 * console.log(note.text); // 'This is a note.'
 */
class Note {
  /**
   * Create a new Note
   * @param {Object|String} [data]              The raw data for this note, either as an object or a string. If a string, the string will become the value of the "text" property of the note.
   * @param {String|Date}   [data.dateCreated]  The date this note was originally created, as either a Date object or a valid date-time string.
   * @param {String|Date}   [data.dateModified] The date this note was last modified, eitehr as a Date object or a valid date-time string.
   * @param {String}        [data.language]     The abbreviation for the language this note is written in. Must be a valid [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
   * @param {String}        [data.person]       The abbreviation of the person who is the source of the information in this note (not necessarily the person who wrote it), as a string. Must be a valid [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
   * @param {String}        data.text           The text of this note, as a string in a single orthography. Create a new note object to use other orthographies.
   * @param {String}        [data.type]         The type of note. Must be one of the following: `note-to-self`, `general`, `anthropology`, `discourse`, `encyclopedic`, `grammar`, `phonology`, `semantics`, `sociocultural`.
   */
  constructor(data = '') {

    // VALIDATION
    if (data instanceof Note) return data;

    if (data && !(typeof data === 'object' || typeof data === 'string')) {
      throw new Error(`The data passed to the Note constructor must be either an Object or a String.`);
    }

    if (typeof data === 'object') {

      if ('language' in data) checkProp(data.language, 'abbr', 'language');

      if ('person' in data) checkProp(data.person, 'abbr', 'person');

      if ('type' in data && !types.includes(data.type)) {
        throw new Error(`Invalid value for the "type" property.`);
      }
    }

    // INSTANTIATION
    if (typeof data === 'string') this.text = data;

    if (typeof data === 'object') {
      this.text = data.text;
      if ('language' in data) this.language = data.language;
      if ('person' in data) this.person = data.person;
      if ('type' in data) this.type = data.type;
    }

    Model.defineProp(this, 'text', String, this.text || '');
    Model.defineProp(this, 'dateCreated', Date, data.dateCreated || new Date());
    Model.defineProp(this, 'dateModified', Date, data.dateModified || new Date());

    // VALIDATION FOR SETTERS
    const handler = {};

    // updates the "dateModified" property anytime a property is added, set, or deleted
    actions.forEach(action => {
      handler[action] = (...args) => {

        const [target, prop] = args;

        if (props.includes(prop)) {
          target.dateModified = new Date();
          return Reflect[action](...args);
        }

        return false;
      };
    });

    return new Proxy(this, handler);
  }

  toJSON() {
    return Model.simplify(this, ['text']);
  }

}

module.exports = Note;

},{"../base":7,"../utilities":32}],22:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');
const Grapheme = require('./Grapheme');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Tags = require('./Tags');

/**
 * A class representing an Orthography
 * @alias Orthography
 * @memberof dlx.module:models
 * @prop {String}          abbreviation An abbreviation for this orthography. This abbreviation will be used as the key for this orthography in any MultiLangString objects.
 * @prop {Array}           graphemes    An Array of Graphemes in this orthography, as Grapheme objects (see the [Orthography schema]{@link http://developer.digitallinguistics.io/spec/schemas/Orthography.html} for more details). Do not include punctuation characters.
 * @prop {MultiLangString} name         The name of this orthography, as a [MultiLangString]{@link dlx.module:models.MultiLangString}
 * @prop {Array}           notes        An Array of notes about this orthography, as [Note objects]{@link dlx.module:models.Note}
 * @prop {Array}           punctuation  An Array of punctuation characters used by this orthography, as Strings
 * @prop {Tags}            tags         Tags for this morpheme, as a [Tags object]{@link dlx.module:models.Tags}
 */
class Orthography {
    /**
     * Create a new Orthography
     * @param {Object}     [data]             The data to use for this Orthography
     * @param {String}     data.abbreviation  An abbreviation for this orthography, formatted as an [abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/Abbreviation.html}
     * @param {Array}      data.graphemes     An array of Graphemes in this orthography, each formatted as a Grapheme object (see the [Orthography schema]{@link http://developer.digitallinguistics.io/spec/schemas/Orthography.html} for more details). Do not include punctuation characters.
     * @param {Object|Map} data.name          The name of this orthography, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}
     * @param {Array}      [data.notes]       An Array of notes about this orthography, formatted as [Note objects]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}
     * @param {Array}      [data.punctuation] An Array of punctuation characters used by this orthography, as Strings
     * @param {Object|Map} [data.tags]        An Object or Map containing tags for this orthography, formatted as a [Tags object]{@link http://developer.digitallinguistics.io/spec/schemas/Tags.html}
     */
    constructor(data = {}) {

        // VALIDATION
        if (!(data instanceof Object)) {
            throw new TypeError(`The data passed to the Orthography constructor must be an Object.`);
        }

        if ('abbreviation' in data) checkProp(data.abbreviation, 'abbr', 'abbreviation');

        // INSTANTIATION
        Object.assign(this, data);

        this.abbreviation = data.abbreviation || '';

        Model.defineProp(this, 'name', MultiLangString, data.name || {});
        Model.defineProp(this, 'tags', Tags, data.tags || {});

        Model.defineArray(this, 'graphemes', Grapheme, data.graphemes);
        Model.defineArray(this, 'notes', Note, data.notes);
        Model.defineArray(this, 'punctuation', String, data.punctuation);

        const handler = {
            set(target, prop, val, proxy) {
                if (prop === 'abbreviation') checkProp(val, 'abbr', 'abbreviation');
                return Reflect.set(target, prop, val, proxy);
            }
        };

        return new Proxy(this, handler);
    }

    toJSON() {
        return Model.simplify(this, ['abbreviation', 'graphemes', 'name']);
    }

}

module.exports = Orthography;

},{"../base":7,"../utilities":32,"./Grapheme":13,"./MultiLangString":20,"./Note":21,"./Tags":28}],23:[function(require,module,exports){
const { Model } = require('../base');
const Note = require('./Note');
const Tags = require('./Tags');

const defaults = { phoneme: '' };

/**
 * A class represting a Phone (Phoneme Token)
 * @alias Phone
 * @memberof dlx.module:models
 * @prop {String} allophone An IPA representation of this particular allophone of the phoneme
 * @prop {Array}  notes     An array of notes about this phone. Each note should be a [Note object]{@link dlx.module:models.Note}.
 * @prop {String} phoneme   An IPA representation of this phoneme
 * @prop {Tags}   tags      A set of tags for this phone, as a [Tags object]{@link dlx.module:models.Tags}.
 */
class Phone {
  /**
   * Create a new Phone
   * @param {Object} [data]           The data to use for this Phone
   * @param {String} [data.allophone] An IPA representation of this particular allophone of the phoneme
   * @param {Array}  [data.notes]     An array of notes about this phone. Each item should be formatted as a [Note object]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
   * @param {String} data.phoneme     An IPA representation of this phoneme
   * @param {Object} [data.tags]      An object containing tags for this phone. Should be formatted as a [Tags object]{@link http://developer.digitallinguistics.io/spec/schemas/Tags.html}.
   */
  constructor(data = defaults) {

    // VALIDATION
    if (!(data instanceof Object)) {
      throw new TypeError(`The "data" argument must be an Object if present.`);
    }

    // INSTANTIATION
    Object.assign(this, data);

    Model.defineProp(this, 'allophone', String, data.allophone || '');
    Model.defineProp(this, 'phoneme', String, data.phoneme || '');
    Model.defineProp(this, 'tags', Tags, data.tags || {});

    Model.defineArray(this, 'notes', Note, data.notes);
  }

  toJSON() {
    return Model.simplify(this, ['phoneme']);
  }

}

module.exports = Phone;

},{"../base":7,"./Note":21,"./Tags":28}],24:[function(require,module,exports){
const { Model } = require('../base');
const Note = require('./Note');
const Reference = require('./Reference');
const Tags = require('./Tags');

const {
  phonologicalFeatures: {
    airstream,
    backness,
    diacritics,
    height,
    length,
    manner,
    place,
    rounding,
    voicing
  }
} = require('../data');

/**
 * A class representing a Phoneme, as an abstract type
 * @alias Phoneme
 * @memberof dlx.module:models
 * @prop {String}  airstream  A String describing the airstream mechanism by which this phoneme is produced. Value must be one of [dlx.data.phonologicalFeatures.airstream]{@link dlx.module:data~airstream}.
 * @prop {Array}   allophones An array of allophones of this phoneme. Each allophone is also a Phoneme object.
 * @prop {String}  backness   A String describing the backness of a vowel. Value must be one of [dlx.data.phonologicalFeatures.backness]{@link dlx.module:data~backness}.
 * @prop {Array}   features   An array of diacritical features of this phoneme, as Strings. Values must be from among the values specified in [dlx.data.phonologicalFeatures.diacritics]{@link dlx.module:data~diacritics}.
 * @prop {String}  height     A String describing the height of a vowel. Value must be one of [dlx.data.phonologicalFeatures.height]{@link dlx.module:data~height}.
 * @prop {String}  ipa        An IPA representation of this phoneme, as a String
 * @prop {String}  length     A String describing the length of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.length]{@link dlx.module:data~length}.
 * @prop {String}  manner     A String describing the manner of articulation of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.manner]{@link dlx.module:data~manner}.
 * @prop {Array}   notes      An Array of notes about this phoneme. Each item is a [Note]{@link dlx.module:models.Note}.
 * @prop {String}  place      A String describing the place of articulation of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.place]{@link dlx.module:data~place}.
 * @prop {String}  rounding   A String describing the type of rounding for this phoneme. Value must be one of [dlx.data.phonologicalFeatures.rounding]{@link dlx.module:data~rounding}.
 * @prop {Tags}    tags       A Map object containing tags for this phoneme, as a [Tags object]{@link dlx.module:models.Tags}.
 * @prop {Phoneme} target1    For diphthongs and triphthongs, use this property to specify the the first target in the pronunciation of the diphthong, as a [Phoneme]{@link dlx.module:models.Phoneme}.
 * @prop {Phoneme} target2    For diphthongs and triphthongs, use this property to specify the the second target in the pronunciation of the diphthong, as a [Phoneme]{@link dlx.module:models.Phoneme}.
 * @prop {Phoneme} target3    For diphthongs, use this property to specify the the third target in the pronunciation of the diphthong, as a [Phoneme]{@link dlx.module:models.Phoneme}.
 * @prop {String}  tone       An abstract representation of the tone of this phoneme, e.g. `H`, `13`, `falling`, etc.
 * @prop {String}  voicing    The voicing value of this phoneme. Must be one of the values in [dlx.data.phonologicalFeatures.voicing]{@link dlx.module:data~voicing}.
 */
class Phoneme {
  /**
   * Create a new Phoneme
   * @param {Object} [data = {}]       The data to use for this phoneme
   * @param {String} [data.airstream]  A String describing the airstream mechanism by which this phoneme is produced. Value must be one of [dlx.data.phonologicalFeatures.airstream]{@link dlx.module:data~airstream}.
   * @param {Object} [data.allophones] An array of allophones of this phoneme. Each allophone follows the same format as the [Phoneme object]{@link http://developer.digitallinguistics.io/spec/schemas/Phoneme.html}.
   * @param {String} [data.backness]   A String describing the backness of a vowel. Value must be one of [dlx.data.phonologicalFeatures.backness]{@link dlx.module:data~backness}.
   * @param {Array}  [data.features]   An array of diacritical features of this phoneme, as Strings. Values must be from among the values specified in [dlx.data.phonologicalFeatures.diacritics]{@link dlx.module:data~diacritics}.
   * @param {String} [data.height]     A String describing the height of a vowel. Value must be one of [dlx.data.phonologicalFeatures.height]{@link dlx.module:data~height}.
   * @param {String} data.ipa          An IPA representation of this phoneme, as a String
   * @param {String} [data.length]     A String describing the length of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.length]{@link dlx.module:data~length}.
   * @param {String} [data.manner]     A String describing the manner of articulation of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.manner]{@link dlx.module:data~manner}.
   * @param {Array}  [data.notes]      An Array of notes about this phoneme. Each item must be formatted as a [Note]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
   * @param {String} [data.place]      A String describing the place of articulation of this phoneme. Value must be one of [dlx.data.phonologicalFeatures.place]{@link dlx.module:data~place}.
   * @param {String} [data.rounding]   A String describing the type of rounding for this phoneme. Value must be one of [dlx.data.phonologicalFeatures.rounding]{@link dlx.module:data~rounding}.
   * @param {Object} [data.tags]       An Object containing tags for this phoneme, formatted as a [Tags object]{@link http://developer.digitallinguistics.io/spec/schemas/Tags.html}.
   * @param {Object} [data.target1]    For diphthongs and triphthongs, use this property to specify the the first target in the pronunciation of the diphthong, formatted as a [Phoneme]{@link http://developer.digitallinguistics.io/spec/schemas/Phoneme.html}.
   * @param {Object} [data.target2]    For diphthongs and triphthongs, use this property to specify the the second target in the pronunciation of the diphthong, formatted as a [Phoneme]{@link http://developer.digitallinguistics.io/spec/schemas/Phoneme.html}.
   * @param {Object} [data.target3]    For triphthongs, use this property to specify the the third target in the pronunciation of the diphthong, formatted as a [Phoneme]{@link http://developer.digitallinguistics.io/spec/schemas/Phoneme.html}.
   * @param {String} [data.tone]       An abstract representation of the tone of this phoneme, e.g. `H`, `13`, `falling`, etc.
   * @param {String} [data.voicing]    The voicing value of this phoneme. Must be one of the values in [dlx.data.phonologicalFeatures.voicing]{@link dlx.module:data~voicing}.
   */
  constructor(data = {}) {

    // VALIDATION
    if (!(data instanceof Object)) {
      throw new TypeError(`The data passed to the Phoneme constructor must be an Object.`);
    }

    // INSTANTIATION
    Object.assign(this, data);

    Model.defineProp(this, 'ipa', String, data.ipa || '');
    Model.defineProp(this, 'tags', Tags, data.tags || {});
    Model.defineProp(this, 'target1', Phoneme, data.target1);
    Model.defineProp(this, 'target2', Phoneme, data.target2);
    Model.defineProp(this, 'target3', Phoneme, data.target3);
    Model.defineProp(this, 'tone', String, data.tone);

    Model.defineEnumProp(this, 'airstream', airstream, data.airstream);
    Model.defineEnumProp(this, 'backness', backness, data.backness);
    Model.defineEnumProp(this, 'height', height, data.height);
    Model.defineEnumProp(this, 'length', length, data.length);
    Model.defineEnumProp(this, 'manner', manner, data.manner);
    Model.defineEnumProp(this, 'place', place, data.place);
    Model.defineEnumProp(this, 'rounding', rounding, data.rounding);
    Model.defineEnumProp(this, 'voicing', voicing, data.voicing);

    Model.defineArray(this, 'allophones', Phoneme, data.allophones);
    Model.defineArray(this, 'notes', Note, data.notes);
    Model.defineArray(this, 'references', Reference, data.references);

    // "features" property
    const features = new Set(data.features);

    Object.defineProperty(this, 'features', {
      configurable: false,
      enumerable: true,
      value: features,
      writable: false
    });

    Object.defineProperty(this.features, 'add', {
      configurable: false,
      enumerable: false,
      value: new Proxy(this.features.add, {
        apply(target, context, [feature]) {
          if (!diacritics.includes(feature)) {
            throw new Error(`The feature value is invalid.`);
          }
          Reflect.apply(target, context, [feature]);
        }
      }),
      writable: false
    });
  }

  toJSON() {
    const data = Model.simplify(this, ['ipa']);
    if (this.features.size) data.features = Array.from(this.features);
    return data;
  }

}

module.exports = Phoneme;

},{"../base":7,"../data":8,"./Note":21,"./Reference":26,"./Tags":28}],25:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');

// don't use destructuring of index.js here - causes problematic circular references
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Tags = require('./Tags');
const Word = require('./Word');

// checks whether the phrase key is properly formatted
const checkKey = key => {
    if (!/^[(a-z)|(A-Z)|(0-9)]+\.[0-9]{1,3}$/.test(key)) {
        throw new Error(`Improperly formatted key.`);
    }
};

// check whether the end time comes before the start time
const checkTimes = (start, end) => {
    if (start > end) throw new Error(`The value of the "endTime" property must be greater than the value of the "startTime" property.`);
};

const defaultPhrase = {
    transcription: {},
    translation: {},
    words: []
};

/**
 * A class representing a Phrase
 * @alias Phrase
 * @memberof dlx.module:models
 * @prop {Number}          endTime       The time within the accompanying media files that this phrase ends, in seconds (decimals allowed).
 * @prop {String}          key           A key that uniquely identifies this phrase within the text, as a string.
 * @prop {String}          language      The abbreviation for the language of this phrase.
 * @prop {Array}           notes         An array of notes about this phrase. Each note is an instance of the [Note class]{@link dlx.module:models.Note}.
 * @prop {String}          speaker       The abbreviation of the speaker of this phrase.
 * @prop {Number}          startTime     The time within the accompanying media files that this phrase begins, in seconds (decimals allowed).
 * @prop {Tags}            tags          A set of tags for this phrase, as a [Map object]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map}.
 * @prop {MultiLangString} transcription The transcriptions for this phrase, as a [MultiLangString]{@link dlx.module:models.MultiLangString}
 * @prop {String}          txn           A shorthand for accessing the default orthography of the `transcription` object, if one is set
 * @prop {MultiLangString} translation   The translations for this phrase, as a [MultiLangString]{@link dlx.module:models.MultiLangString}
 * @prop {String}          tln           A shorthand for accessing the default orthography of the `translation` object, if one is set
 * @prop {String}          url           The URL where this phrase can be accessed.
 * @prop {Array}           words         An array of word tokens in this phrase. Each item is an instance of the [Word class]{@link dlx.module:models.Word}.
 *
 * @example
 * const phrase = new Phrase({
 *
 *   transcription: {
 *     spa:  'Hola, me llamo Daniel.',
 *     ipa:  'ola me jamo dænjɛl',
 *   },
 *
 *   translation: {
 *     eng:  'Hello, my name is Daniel.',
 *     type: 'free',
 *   },
 *
 *   words: [],
 *
 * });
 */
class Phrase extends Model {
    /**
     * Create a new Phrase
     * @param {Object}     [data]                  The raw data for this phrase. See the [DLx specification for Phrases]{@link http://developer.digitallinguistics.io/spec/schemas/Phrase.html} for more information on formatting phrase data.
     * @param {Number}     [data.endTime]          The time within the accompanying media files that this phrase ends, in seconds (decimals allowed).
     * @param {String}     [data.key]              A key that uniquely identifies this phrase within the text, as a string. Must consist of a valid abbreviation, a period, and the number of this phrase within the text (index starts at 1). For example: `A.3` or `DogStory.24`.
     * @param {String}     [data.language]         The abbreviation for the language that this phrase is in. Must be a valid [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
     * @param {Array}      [data.notes]            An array of notes about this phrase. Each note should adhere to the [Note format]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
     * @param {String}     [data.speaker]          The abbreviation of the speaker of this phrase. Must be a valid [Abbreviation]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
     * @param {Number}     [data.startTime]        The time within the accompanying media files that this phrase begins, in seconds (decimals allowed).
     * @param {Map|Object} [data.tags]             An object containing tags and their values. May also be an iterable object, whose items are arrays of tags and their values (in other words, the standard method for instantiating a new Map object; see [MDN's Map documentation]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details).
     * @param {Object}     data.transcription      The transcriptions of this phrase, optionally in multiple orthographies. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Object}     data.translation        The translations of this phrase, optionally in multiple orthographies. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}. May also include a `type` property.
     * @param {String}     [data.translation.type] The type of translation (usually `free` or `literal`).
     * @param {String}     [data.url]              The URL where this phrase can be accessed. Must be a valid URI.
     * @param {Array}      data.words              An array of word tokens in this phrase. Each item must be formatted as a [Word object]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     */
    constructor(data = defaultPhrase) {

        // VALIDATION
        if (data instanceof Phrase) return data;

        if (typeof data !== 'object') {
            throw new Error(`The data passed to the Phrase constructor must be an object.`);
        }

        if (!('endTime' in data && 'startTime' in data || !('endTime' in data || 'startTime' in data))) {
            throw new Error(`The "startTime" and "endTime" properties must either both be absent, or both be present.`);
        }

        if ('endTime' in data) checkProp(data.endTime, 'number', 'endTime');

        if ('key' in data) checkKey(data.key);

        if ('language' in data) checkProp(data.language, 'abbr', 'language');

        if ('speaker' in data) checkProp(data.speaker, 'abbr', 'speaker');

        if ('startTime' in data) checkProp(data.startTime, 'number', 'startTime');

        if ('url' in data) checkProp(data.url, 'url', 'url');

        if (data.startTime) checkTimes(data.startTime, data.endTime);

        // INSTANTIATION
        super();

        Object.assign(this, data);

        Model.defineProp(this, 'tags', Tags, data.tags || {});
        Model.defineProp(this, 'transcription', MultiLangString, data.transcription || {});
        Model.defineProp(this, 'translation', MultiLangString, data.translation || {});

        Model.defineArray(this, 'notes', Note, data.notes);
        Model.defineArray(this, 'words', Word, data.words);

        MultiLangString.alias(this, 'transcription', 'txn');
        MultiLangString.alias(this, 'translation', 'tln');

        if ('endTime' in data) this.endTime = Number(data.endTime.toFixed(3));
        if ('startTime' in data) this.startTime = Number(data.startTime.toFixed(3));

        // VALIDATION FOR SETTERS
        const handler = {
            set(target, prop, val, proxy) {

                switch (prop) {
                    case 'language':
                    case 'speaker':
                        checkProp(val, 'abbr', prop);
                        break;
                    case 'endTime':
                        checkTimes(target.startTime, val);break;
                    case 'key':
                        checkKey(val);break;
                    case 'startTime':
                        checkTimes(val, target.endTime);break;
                    case 'url':
                        checkProp(val, 'url', 'url');break;
                    default:
                        break;
                }

                return Reflect.set(target, prop, val, proxy);
            }
        };

        return new Proxy(this, handler);
    }

    toJSON() {
        return Model.simplify(this, ['transcription', 'translation', 'words']);
    }

}

module.exports = Phrase;

},{"../base":7,"../utilities":32,"./MultiLangString":20,"./Note":21,"./Tags":28,"./Word":30}],26:[function(require,module,exports){
const { Model } = require('../base');

/**
 * A class representing a bibliographic reference
 * @alias Reference
 * @memberof dlx.module:models
 */
class Reference {
  /**
   * Create a new bibliographic reference
   * @param {Object} [data = {}] An object representing the raw data to use for this bibliographic reference. See the [DLx specification for a Reference]{@link http://developer.digitallinguistics.io/spec/schemas/Reference.html} for more information on formatting Reference data.
   */
  constructor(data = { title: '' }) {
    Object.assign(this, data);
  }

  toJSON() {
    return Model.simplify(this, ['title']);
  }

}

module.exports = Reference;

},{"../base":7}],27:[function(require,module,exports){
const { Model } = require('../base');
const { getUniqueReferences } = require('../utilities');

// can't use destructuring on index.js here - causes problematic circular references
const LexemeReference = require('./LexemeReference');
const LexicalRelation = require('./LexicalRelation');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');
const Phrase = require('./Phrase');
const Reference = require('./Reference');
const Tags = require('./Tags');
const Variant = require('./Variant');

/**
 * A class representing a Sense within a Lexeme
 * @alias Sense
 * @memberof dlx.module:models
 * @prop {String} argumentStructure An abstract representation of the argument structure of this sense, as a string.
 * @prop {Object} category          The lexical category, part of speech, or morphosyntactic class for this Lexeme. If the current lexeme is an affix or other grammatical morpheme morpheme, this field should be used to describe the category that the morpheme attaches to. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} cat               A shorthand for accessing the default orthography of the `category` object, if one is set
 * @prop {Object} definition        The definition for this particular sense, optionally in multiple languages. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} def               A shorthand for accessing the default orthography of the `definition` object, if one is set
 * @prop {Object} derives           If this lexeme is a derivational morpheme, this field indicates the type of lexical category, part of speech, or morphosyntactic class that is derived when this morpheme is applied. For example, the English derivational suffix ‑er would have this property set to noun. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} der               A shorthand for accessing the default orthography of the `derives` object, if one is set
 * @prop {Array}  examples          A collection of examples of this sense in use. Each example is a [Phrase]{@link dlx.module:models.Phrase}.
 * @prop {Object} gloss             A Leipzig-style gloss for this sense. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} gl                A shorthand for accessing the default orthography of the `gloss` object, if one is set
 * @prop {Object} inflectionClass   If this lexeme is a root or stem, this field indicates the inflectional class that the sense takes. If this lexeme is an inflectional morpheme, this field indicates the inflectional class that the morpheme belongs to. If this lexeme is a derivational morpheme, this field indicates the inflectional class of the derived form. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} inflection        A shorthand for accessing the default orthography of the `inflectionClass` object, if one is set
 * @prop {Array}  lexicalRelations  An array of lexical relations between this sense and other senses in this lexicon or other lexicons. Each item is a [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Array}  notes             An array of notes about this sense. Each item is a [Note]{@link dlx.module:models.Note}.
 * @prop {Array}  references        An array of bibliographic references about this particular sense. Each item is a [Reference object]{@link dlx.module:models.Reference}.
 * @prop {String} scientificName    The scientific name for this item.
 * @prop {Array}  sources           An array of attested sources for this sense, as strings.
 * @prop {Object} tags              A Map object containing tags for this Lexeme, as a [Tags object]{@link dlx.module:models.Tags}.
 * @prop {Array}  usages            An array of appropriate usages for this sense. Examples include `formal`, `medicinal`, `informal`, etc. Each item is a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {Object} variantOf         A reference to another sense, that this sense is a variant of. [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Array}  variants          An array of variants of this sense. Each item is a [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Object} variantType       If this reference is to a variant of a lexeme or sense, this field can be used to specify the type of variant. Possible values might be a person's name (representing an idiolectal variant), or simply `idiolectal`, or `dialectal` (or the name of the dialect), or `rapid speech`, etc. [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} varType           A shorthand for accessing the default orthography of the `variantType` object, if one is set
 *
 * @example
 * const sense = new Sense({
 *   category:   { eng: 'noun', spa: 'nomino' },
 *   definition: { eng: 'hello (a greeting)', spa: 'hola (un saludo)' },
 *   gloss:      { eng: 'hello', spa: 'hola' },
 * });
 *
 * console.log(sense.category.eng); // 'noun'
 */
class Sense {
    /**
     * Create a new Sense object
     * @param {Object} [data]                   The raw data to create this sense from. Should be formatted as a [Sense object]{@link http://developer.digitallinguistics.io/spec/schemas/Sense.html}.
     * @param {String} [data.argumentStructure] An abstract representation of the argument structure of this sense, as a string.
     * @param {Object} [data.category]          The lexical category, part of speech, or morphosyntactic class for this Lexeme. If the current lexeme is an affix or other grammatical morpheme morpheme, this field should be used to describe the category that the morpheme attaches to. For example, the English verb suffix `‑s` would have this this property set to `verb`, and the English derivational suffix `‑ize` would have this property set to `noun`. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Object} [data.definition]        The definition for this particular sense, optionally in multiple languages. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Object} [data.derives]           If this lexeme is a derivational morpheme, this field indicates the type of lexical category, part of speech, or morphosyntactic class that is derived when this morpheme is applied. For example, the English derivational suffix ‑er would have this property set to noun. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Array}  [data.examples]          A collection of examples of this sense in use. Each example must be formatted as a [Phrase]{@link http://developer.digitallinguistics.io/spec/schemas/Phrase.html}.
     * @param {Object} data.gloss               A Leipzig-style gloss for this sense, formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Object} [data.inflectionClass]   If this lexeme is a root or stem, this field indicates the inflectional class that the sense takes. If this lexeme is an inflectional morpheme, this field indicates the inflectional class that the morpheme belongs to. If this lexeme is a derivational morpheme, this field indicates the inflectional class of the derived form. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Array}  [data.lexicalRelations]  A collection of lexical relations between this sense and other senses in this lexicon or other lexicons. Each item must be formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}.
     * @param {Array}  [data.notes]             A collection of notes about this sense. Each item must be formatted as a [Note]{@link http://developer.digitallinguistics.io/spec/schemas/Note.html}.
     * @param {Array}  [data.references]        A collection of bibliographic references about this particular sense. Each item must be formatted as a [Reference object]{@link http://developer.digitallinguistics.io/spec/schemas/Reference.html}.
     * @param {String} [data.scientificName]    The scientific name for this item.
     * @param {Array}  [data.sources]           An array of attested sources for this sense, as strings. This will often be the initials of a speaker, but could also be the abbreviation of the story the lexeme was found it, or other types of sources.
     * @param {Object} [data.tags]              An object containing tags and their values. May also be an iterable object, whose items are arrays of tags and their values (in other words, the standard method for instantiating a new Map object; see [MDN's Map documentation]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details).
     * @param {Array}  [data.usages]            An array of appropriate usages for this sense. Examples include `formal`, `medicinal`, `informal`, etc. Each item should be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     * @param {Object} [data.variantOf]         If this sense is a variant of another sense, a reference to the other sense should go here. For example, sometimes two speakers may use the same word with a slightly different set of senses. In American English, for instance, Coke is a specific brand of soda for most speakers, but a generic term for soda for other speakers. The generic sense would therefore be listed as a dialectal variant of the specific sense. Must be formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}.
     * @param {Array}  [data.variants]          An array of variants of this sense. Each item must be formatted as a [LexemeReference]{@link http://developer.digitallinguistics.io/spec/schemas/LexemeReference.html}.
     * @param {Object} [data.variantType]       If this reference is to a variant of a lexeme or sense, this field can be used to specify the type of variant. Possible values might be a person's name (representing an idiolectal variant), or simply `idiolectal`, or `dialectal` (or the name of the dialect), or `rapid speech`, etc. Must be formatted as a [MultiLangString]{@link http://developer.digitallinguistics.io/spec/schemas/MultiLangString.html}.
     */
    constructor(data = {}) {

        // VALIDATION
        if (data instanceof Sense) return data;

        if (typeof data !== 'object') {
            throw new Error(`The data passed to the Sense constructor must be an object.`);
        }

        // INSTANTIATION
        Object.assign(this, data);

        Model.defineProp(this, 'argumentStructure', String, data.argumentStructure);
        Model.defineProp(this, 'category', MultiLangString, data.category || {});
        Model.defineProp(this, 'definition', MultiLangString, data.definition || {});
        Model.defineProp(this, 'derives', MultiLangString, data.derives);
        Model.defineProp(this, 'gloss', MultiLangString, data.gloss || {});
        Model.defineProp(this, 'inflectionClass', MultiLangString, data.inflectionClass);
        Model.defineProp(this, 'scientificName', String, data.scientificName);
        Model.defineProp(this, 'tags', Tags, data.tags || {});
        Model.defineProp(this, 'variantOf', LexemeReference, data.variantOf);
        Model.defineProp(this, 'variantType', MultiLangString, data.variantType);

        Model.defineArray(this, 'examples', Phrase, data.examples);
        Model.defineArray(this, 'lexicalRelations', LexicalRelation, getUniqueReferences(data.lexicalRelations || []));
        Model.defineArray(this, 'notes', Note, data.notes);
        Model.defineArray(this, 'references', Reference, data.references);
        Model.defineArray(this, 'sources', String, data.sources);
        Model.defineArray(this, 'usages', MultiLangString, data.usages);
        Model.defineArray(this, 'variants', Variant, getUniqueReferences(data.variants || []));

        MultiLangString.alias(this, 'category', 'pos');
        MultiLangString.alias(this, 'definition', 'def');
        MultiLangString.alias(this, 'derives', 'der');
        MultiLangString.alias(this, 'gloss', 'gl');
        MultiLangString.alias(this, 'inflectionClass', 'inflection');
        MultiLangString.alias(this, 'variantType', 'varType');
    }

    toJSON() {
        return Model.simplify(this, ['gloss']);
    }

}

module.exports = Sense;

},{"../base":7,"../utilities":32,"./LexemeReference":16,"./LexicalRelation":17,"./MultiLangString":20,"./Note":21,"./Phrase":25,"./Reference":26,"./Tags":28,"./Variant":29}],28:[function(require,module,exports){
const isIterable = require('../utilities').isIterable;

const checkStrings = arr => {
  if (!arr.every(val => typeof val === 'string')) {
    throw new Error(`Tags must be strings.`);
  }
};

const checkTagValues = vals => {
  if (vals.some(val => !(typeof val === 'string' || typeof val === 'boolean' || typeof val === 'number'))) {
    throw new Error(`The value of a tag must be a string, boolean, or number.`);
  }
};

/**
 * A class representing a set of Tags
 * @alias Tags
 * @extends Map
 * @memberof dlx.module:models
 *
 * @example
 * const tags = new Tags({
 *   accented:        true,
 *   phraseFinal:     false,
 *   grammaticalRole: 'subject',
 * });
 *
 * tags.set('itemNum', 13);
 *
 * console.log(tags.get('grammaticalRole')); // 'subject'
 * console.log(tags.has('phraseFinal'));     // true
 * console.log(tags.get('itemNum'));         // 13
 * console.log(tags.keys());                 // ['accented', 'phraseFinal', 'grammaticalRole']
 */
class Tags extends Map {
  /**
   * Create a new Tags object. The Tags object is an instance of a Map, and so has all the standard Map methods and properties: `clear`, `delete`, `entries`, `forEach`, `get`, `has`, `keys`, `set`, `size`, and `values`.
   * @param {Object|Iterable} [data] The raw data to use for this Tags object. May either be an object of tags and their values, or an iterable object where each item is an array containing a tag and its value (the standard method of instantiating a Map object; see [MDN's Map documentation]{@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map} for more details.).
   */
  constructor(data = {}) {

    // VALIDATION
    if (typeof data !== 'object') {
      throw new Error(`The data passed to the Tags constructor must be an object.`);
    }

    if (Array.isArray(data)) {
      checkStrings(data.map(item => item[0]));
      checkTagValues(data.map(item => item[1]));
    } else if (isIterable(data)) {
      checkStrings(Array.from(data.keys()));
      checkTagValues(Array.from(data.values()));
    } else {
      checkTagValues(Object.values(data));
    }

    // INSTANTIATION
    if (isIterable(data)) super(data);else super(Object.entries(data));

    Object.defineProperty(this, 'set', {
      configurable: true, // must be configurable for the "Lexeme.prototype.features" property to work
      enumerable: false,
      value: new Proxy(this.set, {
        apply(target, context, args) {
          if (typeof args[0] !== 'string') throw new Error(`Tags must be strings.`);
          return Reflect.apply(target, context, args);
        }
      }),
      writable: false
    });
  }

  /**
   * Returns a pure JavaScript object (POJO) for serialization into JSON using JSON.stringify(). Note that if you call JSON.stringify on a Tags object, it will call the the Tag object's toJSON() method.
   * @return {Object} The JSON representation of the Tags object, as a pure JavaScript object (POJO)
   */
  toJSON() {
    const data = {};
    Array.from(this.entries()).forEach(([key, val]) => {
      data[key] = val;
    });
    return data;
  }

}

module.exports = Tags;

},{"../utilities":32}],29:[function(require,module,exports){
const LexemeReference = require('./LexemeReference');

class Variant extends LexemeReference {
  constructor(data) {
    super(data);
    if (!(this.variantType instanceof Object)) {
      throw new Error(`The variant must have a "variantType" property.`);
    }
  }
}

module.exports = Variant;

},{"./LexemeReference":16}],30:[function(require,module,exports){
const { checkProp } = require('../utilities');
const { Model } = require('../base');

// don't use destructuring of index.js here - causes problematic circular references
const Morpheme = require('./Morpheme');
const MultiLangString = require('./MultiLangString');
const Note = require('./Note');

// checks whether the "key" property is a valid abbreviation
const checkKey = key => {
  if (!/^[(a-z)|(A-Z)|(0-9)]+\.[0-9]{1,3}\.[0-9]{1,2}$/.test(key)) {
    throw new Error(`Improperly formatted key.`);
  }
};

const defaultWord = {
  morphemes: [],
  transcription: {}
};

/**
 * A class representing a Word token
 * @alias Word
 * @memberof dlx.module:models
 * @prop {Object} gloss         The Leipzig gloss for this word, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} key           The uniquely identifying key for this word token
 * @prop {Array}  morphemes     An array of the morphemes or components in this word token. Each item is a [Morpheme]{@link dlx.module:models.Morpheme}.
 * @prop {Array}  notes         An array of notes about this word token. Each item is a [Note object]{@link dlx.module:models.Note}.
 * @prop {Object} transcription The transcriptions of this word token, optionally in multiple orthographies, as a [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {String} txn           A shorthand for accessing the default orthography of the `transcription` object, if one is set
 * @prop {Object} translation   The translations of this word token, optionally in multiple orthographies, as a [MultiLangString]{@link dlx.module:models.MultiLangString}. Note that the translation is not the same as a gloss. Use the translation field for free, natural language translations of a word; use the gloss field for Leipzig-style glosses only.
 * @prop {String} tln           A shorthand for accessing the default orthography of the `translation` object, if one is set
 * @prop {String} url           The URL where this word token can be accessed.
 *
 * @example
 * const word = new Word({
 *
 *   transcription: {
 *     spa: 'hablo',
 *     ipa: 'ablo',
 *   },
 *
 *   translation: {
 *     eng: 'I speak',
 *   },
 *
 *   morphemes: [
 *     { lexeme: 'habl' },
 *     { lexeme: 'o' },
 *   ],
 *
 * });
 *
 * console.log(word.transcription.spa); // 'hablo'
 */
class Word extends Model {
  /**
   * Create a new Word
   * @param {Object} [data]             The raw data for this word token
   * @param {Object} [data.gloss]       The gloss for this word, in [MultiLangString format]{@link http://cdn.digitallinguistics.io/schemas/MultiLangString.json}.
   * @param {String} [data.key]         The uniquely identifying key for this word token, as a string. The key for a phrase consists of the abbreviation of the text, a period, the number of phrase within the text, another period, and then the number of this word within the phrase (indexing starts at 1). For example, for the fourth word of the third phrase of a text with the abbreviation `A`, the key would be `A.3.4`. Keys should be unique within a corpus.
   * @param {Array}  data.morphemes     An array of the morphemes or components in this word token. Each morpheme must be formatted as a [Morpheme]{@link http://cdn.digitallinguistics.io/schemas/Morpheme.json}. May be an empty array.
   * @param {Array}  [data.notes]       An array of notes about this word token. Each note must be in the [Note format]{@link http://cdn.digitallinguistics.io/schemas/Note.json}.
   * @param {Object} data.transcription The transcriptions for this word token, optionally in multiple orthographies, formatted as a [MultiLangString]{@link http://cdn.digitallinguistics.io/schemas/MultiLangString.json}.
   * @param {Object} [data.translation] The translations for this word token, optionally in multiple orthographies, formatted as a [MultiLangString]{@link http://cdn.digitallinguistics.io/schemas/MultiLangString.json}. Note that the translation is not the same as a gloss. Use the translation field for free, natural language translations of a word; use the gloss field for Leipzig-style glosses only.
   * @param {String} [data.url]         The URL where this word token can be accessed. Must be a valid URI.
   */
  constructor(data = defaultWord) {

    // VALIDATION
    if (data instanceof Word) return data;

    if (typeof data !== 'object') {
      throw new Error(`The data passed to the Word constructor must be an object if present.`);
    }

    if ('key' in data) checkKey(data.key);

    if ('url' in data) checkProp(data.url, 'url', 'url');

    // INSTANTIATION
    super();

    Object.assign(this, data);

    Model.defineProp(this, 'gloss', MultiLangString, data.gloss || {});
    Model.defineProp(this, 'transcription', MultiLangString, data.transcription || {});
    Model.defineProp(this, 'translation', MultiLangString, data.translation || {});

    Model.defineArray(this, 'morphemes', Morpheme, data.morphemes);
    Model.defineArray(this, 'notes', Note, data.notes);

    MultiLangString.alias(this, 'transcription', 'txn');
    MultiLangString.alias(this, 'translation', 'tln');

    // VALIDATION FOR SETTERS
    return new Proxy(this, {
      set(target, prop, val, proxy) {

        switch (prop) {
          case 'key':
            checkKey(val);break;
          case 'url':
            checkProp(val, 'url', 'url');break;
          default:
            break;
        }

        return Reflect.set(target, prop, val, proxy);
      }
    });
  }

  toJSON() {
    return Model.simplify(this, ['morphemes', 'transcription']);
  }

}

module.exports = Word;

},{"../base":7,"../utilities":32,"./Morpheme":19,"./MultiLangString":20,"./Note":21}],31:[function(require,module,exports){
/**
 * Data models for linguistic objects, such as Text, Phrase, Word, etc.
 * @memberof dlx
 * @module models
 * @type {Object}
 * @prop {Function} Access            A class representing a set of access protocols. See [Access]{@link dlx.module:models.Access}.
 * @prop {Function} Address           A class representing a postal address. See [Address]{@link dlx.module:models.Address}.
 * @prop {Function} Allomorph         A class representing an Allomorph of a Lexeme. See [Allomorph]{@link dlx.module:models.Allomorph}.
 * @prop {Function} Grapheme          A class representing a Grapheme. See [Grapheme]{@link dlx.module:models.Grapheme}.
 * @prop {Function} Language          A class representing an Language. See [Language]{@link dlx.module:models.Language}.
 * @prop {Function} Lexeme            A class representing a Lexeme. See [Lexeme]{@link dlx.module:models.Lexeme}.
 * @prop {Function} LexemeReference   A class representing a reference to a Lexeme. See [LexemeReference]{@link dlx.module:models.LexemeReference}.
 * @prop {Function} LexicalRelation   A class representing a lexical relation.
 * @prop {Function} Location          A class representing a location. See [Location]{@link dlx.module:models.Location}.
 * @prop {Function} Morpheme          A class representing a token of a morpheme in a corpus. See [Morpheme]{@link dlx.module:models.LexemeReference}.
 * @prop {Function} MultiLangString   A class representing a Multi-Language String. See [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {Function} Note              A class representing a Note. See [Note]{@link dlx.module:models.Note}.
 * @prop {Function} Orthography       A class representing an Orthography. See [Orthography]{@link dlx.module:models.Orthography}.
 * @prop {Function} Phone             A class representing a Phoneme Token. See [Phone]{@link dlx.module:models.Phone}.
 * @prop {Function} Phoneme           A class representing a Phoneme, as an abstract type. See [Phoneme]{@link dlx.module:models.Phoneme}.
 * @prop {Function} Phrase            A class representing a Phrase. See [Phrase]{@link dlx.module:models.Phrase}.
 * @prop {Function} Place             An alias for [Location]{@link dlx.module:models.Location}.
 * @prop {Function} Reference         A class representing a Bibliographic Reference. See [Reference]{@link dlx.module:models.Reference}.
 * @prop {Function} Sense             A class representing a Sense. See [Sense]{@link dlx.module:models.Sense}.
 * @prop {Function} String            An alias for [MultiLangString]{@link dlx.module:models.MultiLangString}.
 * @prop {Function} Tags              A class representing a set of tags, as a Map object. See [Tags]{@link dlx.module:models.Tags}.
 * @prop {Function} Variant           A class representing a lexeme variant reference.
 * @prop {Function} Word              A class representing a Word. See [Word]{@link dlx.module:models.Word}.
 */

module.exports = {
  // NB: The require statements here must match the filenames exactly in order for the tests to work
  Access: require('./Access'),
  Address: require('./Address'),
  Allomorph: require('./Allomorph'),
  Grapheme: require('./Grapheme'),
  Language: require('./Language'),
  Lexeme: require('./Lexeme'),
  LexemeReference: require('./LexemeReference'),
  LexicalRelation: require('./LexicalRelation'),
  Location: require('./Location'),
  Morpheme: require('./Morpheme'),
  MultiLangString: require('./MultiLangString'),
  Note: require('./Note'),
  Orthography: require('./Orthography'),
  Phone: require('./Phone'),
  Phoneme: require('./Phoneme'),
  Phrase: require('./Phrase'),
  Place: require('./Location'),
  Reference: require('./Reference'),
  Sense: require('./Sense'),
  String: require('./MultiLangString'),
  Tags: require('./Tags'),
  Variant: require('./Variant'),
  Word: require('./Word')
};

},{"./Access":10,"./Address":11,"./Allomorph":12,"./Grapheme":13,"./Language":14,"./Lexeme":15,"./LexemeReference":16,"./LexicalRelation":17,"./Location":18,"./Morpheme":19,"./MultiLangString":20,"./Note":21,"./Orthography":22,"./Phone":23,"./Phoneme":24,"./Phrase":25,"./Reference":26,"./Sense":27,"./Tags":28,"./Variant":29,"./Word":30}],32:[function(require,module,exports){
/**
 * A collection of utility functions
 * @module utilities
 * @memberof dlx
 */

const defaultPunctuation = require('./data').punctuation;

/**
 * Creates a new DOM element, and sets its properties
 * @param  {String} type  The type of element to create (e.g. 'div', 'p')
 * @param  {Object} props An object of properties and their values to assign to the new element
 * @return {Object}       Returns the new DOM Node
 */
const createElement = (type, props) => Object.assign(document.createElement(type), props);

/**
 * Returns an array of all the unique characters in a string. Works with both UTF-8 and UTF-16 encoding.
 * @param  {String} string The string to retrieve unique characters from
 * @return {Array}         Returns an array of the unique characters
 * @instance
 */
const getUniqueChars = string => {

  if (typeof string !== 'string') {
    throw new TypeError('The argument passed to "getUniqueChars" must be a string.');
  }

  return Array.from(new Set(string));
};

// filters an array of LexemeReference objects and returns only JSON-unique ones
const getUniqueReferences = (references = []) => {

  if (!Array.isArray(references)) {
    throw new TypeError(`The references must be an Array.`);
  }

  const uniques = [];

  const isEqual = (obj1, obj2) => {

    const stringsEqual = obj1.lexicon === obj2.lexicon && obj1.lexeme === obj2.lexeme && obj1.relation === obj2.relation && obj1.sense === obj2.sense;

    if (stringsEqual) {

      if (obj1.variantType && obj2.variantType) {

        return Object.entries(obj1.variantType).every(([key, val]) => val === obj2.variantType[key]) && Object.entries(obj2.variantType).every(([key, val]) => val === obj1.variantType[key]);
      } else if (obj1.variantType || obj2.variantType) {

        return false;
      }

      return true;
    }

    return false;
  };

  references.forEach(ref => {
    if (!uniques.some(obj => isEqual(obj, ref))) uniques.push(ref);
  });

  return uniques;
};

/**
 * Tests whether a string is a valid abbreviation according to the [DLx Abbreviation schema]{@link http://developer.digitallinguistics.io/spec/schemas/abbreviation.html}.
 * @param  {String} string The string to test
 * @return {Boolean}       Returns true if the string is a valid abbreviation, false otherwise
 */
const isAbbr = string => {
  if (typeof string === 'string') return (/^[(a-z)|(A-Z)|(0-9)]+$/.test(string)
  );
  return false;
};

/**
 * Tests whether a string is a valid ISO Internet Date-Time string.
 * @param  {String}  string The string to test
 * @return {Boolean}        Returns true if the string is a valid date
 */
const isDateString = string => !isNaN(Date.parse(string));

// check whether an item is iterable
const isIterable = obj => {
  if (!obj) return false;
  return typeof obj[Symbol.iterator] === 'function';
  // NB: cannot use 'in' here because 'obj' might be a string
};

/**
 * Tests whether a string is a valid URI. Code taken from http://stackoverflow.com/questions/8667070/javascript-regular-expression-to-validate-url/15855457#15855457
 * @type {Function}
 * @param {String} string       The string to validate
 * @return {Boolean}            Returns true if the string is a valid URI, false otherwise
 */
const isUrl = string => /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(string);

/**
 * Checks whether an item is valid for the specified type, and returns a generic error message with the provided property name if not.
 * @param  {Any}    item The item to check
 * @param  {String} type The type to check for
 * @param  {String} prop The name of the property to use in the error message
 * @return {Any}         Returns the original value if no error is thrown
 */
const checkProp = (...args) => {

  if (args.length !== 3) throw new Error('Missing arguments to chceckProp function.');

  const [item, type, prop] = args;

  switch (type) {

    case 'abbr':
      {
        if (!isAbbr(item)) throw new Error(`The "${prop}" property must be a valid abbreviation.`);
        break;
      }

    case 'array':
      {
        if (!Array.isArray(item)) throw new Error(`The "${prop}" property must be an array.`);
        break;
      }

    case 'date':
      {
        if (isNaN(Date.parse(item))) throw new Error(`The "${prop}" property must be a valid date.`);
        break;
      }

    case 'integer':
      {
        if (!Number.isInteger(item)) throw new Error(`The "${prop}" property must be an integer.`);
        break;
      }

    case 'iterable':
      {
        if (!isIterable(item)) throw new Error(`The "${prop}" property must be an iterable object.`);
        break;
      }

    case 'number':
      {
        if (typeof item !== 'number') throw new Error(`The "${prop}" property must be a number.`);
        break;
      }

    case 'object':
      {
        if (typeof item !== 'object') throw new Error(`The "${prop}" property must be an object.`);
        break;
      }

    case 'string':
      {
        if (typeof item !== 'string') throw new Error(`The "${prop}" property must be a string.`);
        break;
      }

    case 'url':
      {
        if (!isUrl(item)) throw new Error(`The "${prop}" property must be a valid URI.`);
        break;
      }

    default:

  }

  return item;
};

/**
 * Performs a series of substitutions on a string, replacing unwanted characters with the desired ones (or nothing, meaning the character is simply removed everywhere it occurs).
 * NB: This function cannot properly handle cases where the output of one substitution is also the input of another subsitition (e.g. if you pass it both `ch` => `c` and `c` => `k`).
 * @param  {String} string        The string to sanitize
 * @param  {Object} substitutions An object whose attributes are the characters you wish to replace, and values are the characters you wish to replace them with
 * @return {String}               Returns the sanitized string, with substitutions made
 * @instance
 */
const sanitize = (string, substitutions) => {

  if (typeof string !== 'string') {
    throw new TypeError('The first argument passed to "sanitize" must be a string.');
  }

  if (!(typeof substitutions === 'object' && Object.values(substitutions).every(val => typeof val === 'string')
  // NB: Object attributes are always strings, so the keys don't need checking
  )) {
    throw new TypeError('The second argument passed to "sanitize" must be an object whose attributes and values are strings.');
  }

  let str = string;
  const badChars = Object.keys(substitutions);

  badChars.sort((a, b) => a.length < b.length ? 1 : -1);

  badChars.forEach(char => {
    const goodChar = substitutions[char];
    // escape any regular expression characters (regex taken from MDN)
    const badChar = char.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
    const regexp = new RegExp(badChar, 'gu');
    str = str.replace(regexp, goodChar);
  });

  return str;
};

/**
 * Takes an HTML string and converts it to DOM nodes
 * @param  {String} html an HTML string
 * @return {Array}       returns an array of DOM nodes
 */
const toDOM = html => {
  if (html instanceof Node) return [html];
  const template = document.createElement('template');
  template.innerHTML = html;
  return Array.from(template.content.children || []);
};

/**
 * Removes punctuation from a string, and then tokenizes the string, returning an array of tokens.
 * @param  {String} string      The string to tokenize
 * @param  {Array}  delimiters  An array of characters to tokenize the string with
 * @param  {Array}  punctuation An array of punctuation characters to remove from the string
 * @return {Array}              Returns an array of tokens
 * @instance
 */
const tokenize = (string, delimiters, punctuation) => {

  // NB: Don't use default parameters, since they don't allow `null` to be passed.
  const delims = delimiters || ['\\s'];
  const punct = punctuation || defaultPunctuation;

  if (typeof string !== 'string') {
    throw new TypeError('The "string" argument must be a string.');
  }

  if (!(Array.isArray(delims) && Array.isArray(punct))) {
    throw new TypeError('The "delimiters" and "punctuation" arguments must be arrays.');
  }

  const substitutions = {};

  punct.forEach(item => {
    substitutions[item] = '';
  });

  const depunctuated = sanitize(string, substitutions);
  const pattern = `[${delims.join('')}]+`;
  const regexp = new RegExp(pattern, 'gu');

  return depunctuated.split(regexp);
};

/**
 * Converts a string from one writing system to another.
 * @param {String} string         The string to transliterate.
 * @param {Object} substitutions  A hash of substitutions to make on the string. Each key in the object should be a string to replace, and its value should be the string to replace it with.
 * @return {String}               Returns the transliterated string
 * @instance
 */
const transliterate = (string, substitutions) => {

  if (typeof string !== 'string') {
    throw new TypeError('The first argument passed to "transliterate" must be a string.');
  }

  if (!(typeof substitutions === 'object' && Object.values(substitutions).every(val => typeof val === 'string'))) {
    throw new TypeError('The second argument passed to "substitutions" must be an object whose attributes and values are strings.');
  }

  const duplicates = new Map();
  const subs = new Map();
  let str = string;

  const inputs = Object.keys(substitutions).sort((a, b) => a.length < b.length ? 1 : -1);
  inputs.forEach(input => subs.set(input, substitutions[input]));

  subs.forEach((replacement, input) => {

    // check whether any substitution overlaps with another substitution
    // temporarily replace the duplicate substitution with a random number if so
    if (inputs.includes(replacement)) {
      const temp = Math.floor(Math.random() * 100000);
      duplicates.set(temp, replacement);
      subs.set(input, temp);
    }

    // make the substitutions using the temporary placeholders
    const regexp = new RegExp(input, 'gu');
    str = str.replace(regexp, subs.get(input));
  });

  // now replace the temporary placeholders with their proper values
  duplicates.forEach((replacement, temp) => {
    const regexp = new RegExp(temp, 'gu');
    str = str.replace(regexp, replacement);
  });

  return str;
};

module.exports = {
  checkProp,
  createElement,
  getUniqueChars,
  getUniqueReferences,
  isAbbr,
  isDateString,
  isIterable,
  isUrl,
  sanitize,
  toDOM,
  tokenize,
  transliterate
};

},{"./data":8}],33:[function(require,module,exports){
/**
 * Views for displaying linguistic data, e.g. Text, Phrase, Word, etc.
 * @memberof dlx
 * @module views
 * @type {Object}
 */

module.exports = {};

},{}]},{},[9])(9)
});