/**
 * Base models for other types of classes
 * @memberof dlx
 * @module base
 * @type {Object}
 * @prop {Function} Collection  A base class for Collections
 * @prop {Function} DOMListener A DOM Listener object
 * @prop {Function} Emitter     A base class for Event Emitters
 * @prop {Function} ListView    A base class for List Views
 * @prop {Function} Model       A base class for Models
 * @prop {Function} View        A base class for Views
 */

module.exports = {
  Collection:  require('./Collection'),
  DOMListener: require('./DOMListener'),
  Emitter:     require('./Emitter'),
  ListView:    require('./ListView'),
  Model:       require('./Model'),
  View:        require('./View'),
};
