/* global dlx */

/* eslint-disable
  func-names,
  max-nested-callbacks,
  max-statements,
  no-magic-numbers,
  no-shadow,
  object-curly-newline,
  object-property-newline,
  prefer-arrow-callback
*/

describe('dlx.base.Collection', function() {

  const { Collection } = dlx.base;
  const { Tags }       = dlx.models;

  it('Errors', function() {

    expect(() => new Collection({})).toThrow();
    expect(() => new Collection).not.toThrow();

    const coll = new Collection([], { model: Tags });
    expect(() => { coll[0] = {}; }).not.toThrow();
    expect(coll[0] instanceof Tags).toBe(true);

  });

  it('new Collection()', function() {

    const oldColl = new Collection;
    const newColl = new Collection(oldColl);
    expect(oldColl.emit instanceof Function).toBe(true);
    expect(newColl).toBe(oldColl);

    const obj = { jambo: 'dunia' };
    const coll = new Collection([obj]);
    expect(coll[0]).toBe(obj);

    const collection = new Collection([{}, {}], { model: Tags });
    expect(collection.length).toBe(2);
    expect(collection.every(item => item instanceof Tags)).toBe(true);

  });

  it('Collection.prototype.push', function() {
    const coll = new Collection([], { model: Tags });
    coll.push({});
    expect(coll[0] instanceof Tags).toBe(true);
  });

});
