/* global dlx */

/* eslint-disable
  func-names,
  init-declarations,
  max-nested-callbacks,
  max-statements,
  no-magic-numbers,
  no-shadow,
  object-curly-newline,
  object-property-newline,
  prefer-arrow-callback
*/

describe('dlx.models.Grapheme', function() {

  const { Grapheme, MultiLangString } = dlx.models;

  const data = {
    allographs:     ['ʃ'],
    customProperty: 'customValue',
    pronunciations: ['ʃ', 's'],
  };

  let grapheme;

  it('Errors', function() {
    expect(() => new Grapheme(true)).toThrow();
    expect(() => new Grapheme({})).not.toThrow();
  });

  it('new Grapheme()', function() {
    expect(() => { grapheme = new Grapheme(data); }).not.toThrow();
  });

  it('Grapheme.prototype.{customProperty}', function() {
    expect(grapheme.customProperty).toBeUndefined();
    grapheme.custom = 'hello';
    expect(grapheme.custom).toBeUndefined();
  });

  it('Grapheme.prototype.allographs', function() {
    expect(grapheme.allographs[0]).toBe(data.allographs[0]);
    expect(() => grapheme.allographs.push(true)).toThrow();
  });

  it('Grapheme.prototype.form', function() {
    expect(new Grapheme().form).toBeDefined();
  });

  it('Grapheme.prototype.name', function() {
    expect(grapheme.name instanceof MultiLangString).toBe(true);
  });

  it('Grapheme.prototype.pronunciations', function() {
    expect(grapheme.pronunciations[0]).toBe(data.pronunciations[0]);
    expect(() => grapheme.pronunciations.push(true)).toThrow();
  });

});
