/* global dlx */

/* eslint-disable
  func-names,
  max-nested-callbacks,
  max-statements,
  no-magic-numbers,
  no-shadow,
  object-curly-newline,
  object-property-newline,
  prefer-arrow-callback
*/

describe('ListView', function() {

  const { Collection, ListView, View } = dlx.base;

  const container      = document.querySelector('#Test .container');

  const coll     = new Collection;
  const listView = new ListView(coll, { container: '#Test .container' });

  beforeAll(function() {
    container.innerHTML = '';
  });

  it('Errors', function() {
    const badData = () => new ListView({});
    expect(badData).toThrow();
  });

  it('new ListView()', function() {
    expect(listView instanceof View).toBe(true);
  });

  it('ListView.prototype.collection', function() {
    expect(listView.collection instanceof Collection).toBe(true);
  });

  it('ListView.prototype.view', function() {

    expect(listView.view).toBe(View);

    const lv = new ListView(coll, { view: View });
    expect(lv.view).toBe(View);

  });

  it('ListView.prototype.template()', function() {
    expect(listView.template().tagName).toBe('UL');
  });

  it('ListView.prototype.render()', function() {
    expect(() => listView.render({ container })).not.toThrow();
  });

  afterAll(function() {
    container.innerHTML = '';
  });

});
